-- 악기상점 오픈(810010) -- 진입형 퀘스트
-- version("0.31.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520303)  -- 악기상점 관련 기능을 열어줌
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
    --TODO
    return true
end

--유저가 악기장인 이서크를 터치해서 줌인한 후 [악기상점] 버튼 누르면 악기상점으로 진입한 상태에서 진행
--이 퀘스트를 진행 가능한 상태가 되면, 악기장인 이서크가 아주 눈에 띄는 동작으로 파닥거림(유저에게 나를 봐달라는 느낌으로), [악기상점] 버튼에 NEW 표시
--진입 튜토리얼의 경우, 어두운 화면에 퀘스트 제목 뜨는 과정 없음

-- PRELOAD_BEGIN

local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    -- 기존의 배경음 백업
    SoundGetDvmBase64()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    -- SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(69) --=BGM=Theme_Instrumentshop

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    QuestStart()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(810010001))  -- "뮤직비디오에 쓸 {highlight}{bold}음악{/bold}{/highlight}은 꼭 {highlight}{bold}신서사이저{/bold}{/highlight}로 만들어야 합니다."
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(810010002))  -- "'{highlight}{bold}부활의 춤{/bold}{/highlight}' 이후에는 모두 그렇게 하죠.(아, '{highlight}{bold}부활의 춤{/bold}{/highlight}'을 모르나?)"
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(810010003))  -- "{highlight}{bold}초대 전설춤꾼{/bold}{/highlight}이 {highlight}{bold}신서사이저{/bold}{/highlight}로 만든 신성한 음악과 신들린 춤으로 댄스빌을 구한 역사적인 사건 말입니다."
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(810010004))  -- "하지만 {highlight}{bold}신서사이저{/bold}{/highlight}로 음악에 쓸 소리, 즉 {highlight}{bold}악기{/bold}{/highlight} 만들기는 쉽지 않아요."
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(810010005))  -- "그래서 저 같은 사람이 필요한 겁니다. #찡긋 #전문가"
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(810010006))  -- "{highlight}{bold}신서사이저{/bold}{/highlight}로 만든 다양한 {highlight}{bold}악기{/bold}{/highlight}들을 팔고 있으니 구경 환영."
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(810010007))  -- "{highlight}{bold}신서사이저{/bold}{/highlight}도 파냐구요? 물론입니다."

    Wait(0.5)

    QuestComplete()
    QuestReward()

    -- 백업했던 배경음 플레이하고 제거
    SoundPlayBGMBase64()
    SoundClearBase64()

    -- 동작을 복구
    TownCharacterSetDanceRestore( TownCharacterAddNPC(164))

    --진입 튜토리얼이 끝나면 마을로 돌아가지 않고 해당 UI에 머물러 있는 상태
end

if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then

    -- 마을 갱신 시, 악기장인 이서크 표시
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40)
        TownCharacterAction(TownCharacterGetNPC(164), "cheer_01")
        TownCharacterSetIconSetTimeStamp(TownCharacterGetNPC(164), "DANCER_TALK")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(164), 610002)

        UnlockQuestContents()
    end
    -- 악기상점 팝업 진입 시, 악기상점 버튼에 New표시
    if OnGameAction("OnAfterPopupEntered/PopupTownInstShop") then
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_012_07", "btn_shop_instr", "btn_shop_instr/iconNew", 52, 30)
    end

    -- 악기상점 버튼 클릭 시
    if OnGameAction("OnBlockUIClick/PopupTownInstShop/btn_shop_instr") then
        UIRemoveNewIconWithCCB("UI_common/ui_btn2_012_07", "btn_shop_instr", "btn_shop_instr/iconNew")
    end
	
	-- 악기 상점 진입 시, 퀘스트 진행 시작
    if OnGameAction("OnAfterSceneEntered/SceneMusicInstShop") then
        ScriptOnQuest()
    end
end




-- PRELOAD_END
-- 퀘스트 다시하기
if OnQuestReplay() then
    --TODO
end
