-- 무역상점 오픈(810011) -- 진입형 퀘스트
-- version("0.31.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520304)  -- 무역상점 관련 기능을 열어줌
end


-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO
    return true
end

--유저가 무역상 오르카를 터치해서 줌인한 후 [무역상점] 버튼 누르면 무역상점으로 진입한 상태에서 진행
--이 퀘스트를 진행 가능한 상태가 되면, 무역상 오르카가 아주 눈에 띄는 동작으로 파닥거림(유저에게 나를 봐달라는 느낌으로), [무역상점] 버튼에 NEW 표시
--진입 튜토리얼의 경우, 어두운 화면에 퀘스트 제목 뜨는 과정 없음

-- PRELOAD_BEGIN

local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    -- SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(66) --=BGM=Theme_Tradeshop

	-- 대사 스킵
	AddQuestSkipButton()

    QuestStart()

    DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(810011001))  -- "{highlight}{bold}희귀한 인테리어 물품{/bold}{/highlight}이나 {highlight}{bold}소모품{/bold}{/highlight}을 찾고 있나?"
    DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(810011002))  -- "그렇다면 제대로 찾아왔어."
    DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(810011003))  -- "바다 건너 세상의 유행하는 물건들까지 다 있으니 마음껏 골라봐."
    DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(810011004))  -- "다른 데서는 이만한 물건들 구하기 어려울 거야."
    DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(810011005))  -- "'바다의 괴물'로 불리는 이 오르카 님께서 해상무역을 장악했으니 말이야. 하하하."

    Wait(0.5)

    QuestComplete()
    QuestReward()

    -- 동작을 복구
    TownCharacterSetDanceRestore( TownCharacterAddNPC(163))

    --진입 튜토리얼이 끝나면 마을로 돌아가지 않고 해당 UI에 머물러 있는 상태
end

if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then

    -- 마을 갱신 시, 무역상 오르카 표시
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(163), 16*40, 32*40)
        TownCharacterAction(TownCharacterGetNPC(163), "cheer_01")
        TownCharacterSetIconSetTimeStamp(TownCharacterGetNPC(163), "DANCER_TALK")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(163), 610002)

        UnlockQuestContents()
    end

    -- 무역상점 팝업 진입 시, 무역상점 버튼에 New표시
    if OnGameAction("OnAfterPopupEntered/PopupTownTradeShop") then
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_012_04", "btn_shop_trade", "btn_shop_trade/iconNew", 52, 30)
    end

    -- 무역상점 버튼 클릭 시
    if OnGameAction("OnBlockUIClick/PopupTownTradeShop/btn_shop_trade") then
        UIRemoveNewIconWithCCB("UI_common/ui_btn2_012_04", "btn_shop_trade", "btn_shop_trade/iconNew")
    end
	
	    -- 무역 상점 진입 시, 퀘스트 진행 시작
    if OnGameAction("OnAfterSceneEntered/SceneShopTrade") then
        ScriptOnQuest()
    end
end





-- PRELOAD_END

--퀘스트 다시하기
if OnQuestReplay() then
 	--TODO
end
