-- 빨리 유명해지는 방법(810013) -- 진입 퀘스트
-- version("0.36.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520011)  -- 뮤비 촬영/뮤비 목록 기능을 열어줌
    UnlockContents(520042)  -- 경연 기능 오픈
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
      --TODO
    return true
end

-- PRELOAD_BEGIN

--유저가 [경연] 버튼을 누르면 경연 화면에 진입한 상태로 스크립트 진행
--이 퀘스트를 진행 가능한 상태가 되면, [경연] 버튼에 new 표시(마을의 댄스비전에도 new 표시)


local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001",STR_QUEST_TEXT(810013001))  -- "{highlight}{bold}댄스비전{/bold}{/highlight}으로 뭘 그렇게 유심히 보고 계시나 했더니 {highlight}{bold}경연{/bold}{/highlight} 화면을 보고 계셨군요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001",STR_QUEST_TEXT(810013002))  -- "{highlight}{bold}경연{/bold}{/highlight}에는 누구나 참여해서 {highlight}{bold}자신의 뮤직비디오{/bold}{/highlight}를 다른 춤꾼들에게 {highlight}{bold}소개{/bold}{/highlight}하고 {highlight}{bold}평가{/bold}{/highlight}받을 수 있어요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001",STR_QUEST_TEXT(810013003))  -- "만약에 좋은 평가를 받아서 {highlight}{bold}높은 순위{/bold}{/highlight}에 오르면 {highlight}{bold}춤꾼들의 찬사{/bold}{/highlight}와 {highlight}{bold}두둑한 보상{/bold}{/highlight} 뿐 아니라..."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001",STR_QUEST_TEXT(810013004))  -- "두고두고 {highlight}{bold}역대 경연 기록{/bold}{/highlight}에 남게 되니 그야말로 명예로운 일이라 할 수 있죠!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001",STR_QUEST_TEXT(810013005))  -- "꼭 참가하지 않더라도, 참가작들 중에 마음에 드는 것에 {highlight}{bold}투표{/bold}{/highlight}하는 재미도 꽤나 좋구요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001",STR_QUEST_TEXT(810013006))  -- "경연은 춤꾼협회에서 {highlight}{bold}주기적으로 개최{/bold}{/highlight}하니까 {highlight}{bold}경연 기간{/bold}{/highlight}이 되면 잊지말고 꼭 참석해보세요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001",STR_QUEST_TEXT(810013007))  -- "유명한 춤꾼이 되어 {highlight}{bold}하늘에서 떨어진 자{/bold}{/highlight}들의 눈에 띌 좋은 기회가 될 수도 있잖아요?"

    -- 퀘스트 완료
    Wait(1)

    -- 퀘스트 시작/완료/보상(진입 튜토리얼은 완료, 보상 팝업 안 뜸)
    QuestStart()
    QuestComplete()
    QuestReward()

    --진입 튜토리얼이 끝나면 마을로 돌아가지 않고 해당 UI에 머물러 있는 상태
end

if CheckQuestAppear() then
    -- 마을 진입 시, 마을의 댄스비전에 new 표시
    if OnTownRefresh() then
        UIAddNewIconAt("btnDanceVision", "btnDanceVision/iconNew", 102, 72)
    end
end

if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then
    -- 댄스비전에 들어가면 경연 버튼 해금
    -- 댄스비전 진입 전에 unlock해야해서 여기서 바로 호출
    UnlockQuestContents()

    -- 댄스비전에 들어가면 경연 버튼에 New표시
    if OnGameAction("OnAfterSceneEntered/SceneDanceVision") then
        UnlockQuestContents()
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_018_01", "btn_contest1", "btn_contest1/iconNew", 35, 30)
    end

	-- 댄스비전 버튼 눌렀을 때 new 표시 제거
	if OnGameAction("OnUIClick/SceneDanceVision/btnDanceVision") then
		UIRemoveNewIcon("btnDanceVision", "btnDanceVision/iconNew")
	end
	
    -- 경연 버튼 클릭 시, 경연 버튼에 New표시 제거
    if OnGameAction("OnUIClick/SceneDanceVision/btn_contest1") then
        UIRemoveNewIconWithCCB("UI_common/ui_btn2_018_01", "btn_contest1", "btn_contest1/iconNew")
    end
    -- 경연 화면 진입 시, 퀘스트 진행 시작
    if OnGameAction("OnAfterSceneEntered/SceneContestLobby") then
        ScriptOnQuest()
    end

    if OnGameAction("OnAfterSceneEntered/SceneContestList") then
        ScriptOnQuest()
    end
end


-- PRELOAD_END

if OnQuestReplay() then
  --TODO
end
