  -- 춤 이어서 추기(810014) -- 진입 퀘스트
-- version("0.40.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520001)  -- 춤 관련 기능을 열어줌
    UnlockContents(520043)  -- 춤 잇기 관련 기능을 열어줌
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
      --TODO
    return true
end


-- PRELOAD_BEGIN

--유저가 [춤잇기] 버튼을 누르면 [춤잇기]의 이을 춤 선택 화면 내부에 진입한 상태로 스크립트 진행
--이 퀘스트를 진행 가능한 상태가 되면, [춤잇기] 버튼에 new 표시(유저 캐릭터 바로 가기 버튼, 춤 버튼, 춤 추가 버튼에도 new 표시)

local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 퀘스트 배경음
    SoundPlayBGM(629054) --=BGM=Character_Mr.CABA

    -- 스킵 버튼 활성화
    AddQuestSkipButton()
    
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_009",STR_QUEST_TEXT(810014001))  -- "마침 {highlight}{bold}춤 잇기{/bold}{/highlight}를 살펴보고 있었군."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_009",STR_QUEST_TEXT(810014002))  -- "춤을 만드는 방법에 한 가지가 더 있다는 사실을 알려주지 않은 것 같아 이렇게 달려왔다네."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006",STR_QUEST_TEXT(810014003))  -- "그것이 바로 지금 보고 있는 {highlight}{bold}춤 잇기{/bold}{/highlight}!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002",STR_QUEST_TEXT(810014004))  -- "이름 그대로, 자네가 알고 있는 춤들을 이어서 새로운 춤을 만드는 것이지."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002",STR_QUEST_TEXT(810014005))  -- "그저 기존에 있던 {highlight}{bold}춤들을 원하는 순서대로 잇기{/bold}{/highlight}만 하면 되니까 어려울 것이 전혀 없겠지?"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_009",STR_QUEST_TEXT(810014006))  -- "물론, 춤을 적어도 하나 정도는 알고 있어야 쓸 수 있는 방식이긴 하지만 말일세."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006",STR_QUEST_TEXT(810014007))   -- "자네라면 어떤 방식으로든 훌륭한 춤을 만들어내겠지. 기대하고 있겠네."
        
    -- 퀘스트 완료
    Wait(1)

    -- 퀘스트 시작/완료/보상(진입 튜토리얼은 완료, 보상 팝업 안 뜸)
    QuestStart()
    QuestComplete()
    QuestReward()

    --진입 튜토리얼이 끝나면 마을로 돌아가지 않고 해당 UI에 머물러 있는 상태
end

if CheckQuestAppear() then
    -- 마을/댄스비전 진입 시, 유저 캐릭터 바로가기 버튼에 new 표시
    if OnTownRefresh() or OnGameAction("OnAfterSceneEntered/SceneDanceVision") then
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_001_01", "btn_myavt", "btn_myavt/iconNew", 29, 41)
        UIShowWithCCB( "UI_common/ui_icon_new5_main_topbar", "icon_new_ByCCB")
    end
end

if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then

    -- 내 춤꾼 팝업 진입 시, 춤 버튼에 New표시
    if OnGameAction("OnAfterPopupEntered/PopupTownUser") then
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_003_05", "btn_info_dance", "btn_info_dance/iconNew", 29, 41)
    end

    if OnGameAction("OnAfterSceneEntered/SceneMyInfo") then
        UIAddNewIconAt("btn_info_dance", "btn_info_dance/iconNew1", 29, 41)
    end

    -- 춤 목록 화면 진입 시, 춤 추가 버튼에 New표시
	if OnGameAction("OnAfterSceneEntered/SceneDanceList") then
		UIAddNewIconAtWithCCB("UI_common/ui_btn2_004_02", "btn_add", "btn_add/iconNew", 35, 30)
    end

    -- 춤 추가 버튼 클릭 시, 유저 캐릭터 바로가기 버튼 new 표시 제거, 춤 버튼에 New표시 제거, 춤 추가 버튼에 New표시 제거
    if OnGameAction("OnUIClick/SceneDanceList/btn_add") then
        UIRemoveNewIconWithCCB("UI_common/ui_btn2_001_01", "btn_myavt", "btn_myavt/iconNew")
        UIRemoveNewIconWithCCB("UI_common/ui_btn2_003_05", "btn_info_dance", "btn_info_dance/iconNew")
        UIRemoveNewIcon("btn_info_dance", "btn_info_dance/iconNew1")
        UIHideWithCCB( "UI_common/ui_icon_new5_main_topbar", "icon_new_ByCCB")
        RefreshNewCount()
    end

    -- 춤꾼들 화면 진입 시, 퀘스트 진행 시작
    -- 춤 추가 눌러서 제작 방식 목록이 뜨면, 춤잇기 버튼 해금
    if OnGameAction("OnAfterSceneEntered/SceneDanceMode") then
        UnlockQuestContents()
        UIRemoveNewIconWithCCB("UI_common/ui_btn2_004_02", "btn_add", "btn_add/iconNew")
        ScriptOnQuest()
    end
end





-- PRELOAD_END

if OnQuestReplay() then
  --TODO
end
