-- 구경 가기(810015) -- 진입 퀘스트
-- version("0.51.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
      --TODO
    return true
end

-- PRELOAD_BEGIN


local function ScriptOnQuest()
    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    
    -- 유저 캐릭터 줌인
	TownCharacterStandAt(TownCharacterGetUserOtherTown(), 0*40, 33*40-182)
    TownCameraZoomIn(TownCharacterGetNPCOtherTown(0, 1), 0, 50, 2)
    Wait(1)

    -- 화면 우측 인상 좋은 청년 등장, 카메라 줌인
    TownCharacterStandAt(TownCharacterAddNPCOtherTown(111), 360, 33*40-182)
    TownCameraZoomIn(TownCharacterGetNPCOtherTown(0, 111), -60, 50, 2)
    Wait(1)

    -- 인상 좋은 청년이 유저 캐릭터 우측으로 걸어온다
    TownCharacterWalkTo(TownCharacterGetNPCOtherTown(0, 111), 120, 33*40-182)
    Wait(2)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001",STR_QUEST_TEXT(810015001))  -- "앗! [유저의 닉네임] 님께서 이 마을까지 어쩐 일로?"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001",STR_QUEST_TEXT(810015002))  -- "전 이 마을 아카데미의 마스터의 {highlight}{bold}팬{/bold}{/highlight}이라, 크루의 {highlight}{bold}아르바이트{/bold}{/highlight}를 좀 도와주려고 왔어요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001",STR_QUEST_TEXT(810015003))  -- "{highlight}{bold}스타로 등록한 마스터의 마을{/bold}{/highlight}에서 {highlight}{bold}아르바이트를 하고 있는 크루{/bold}{/highlight}에게 말을 걸면 도와줄 수 있거든요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001",STR_QUEST_TEXT(810015004))  -- "그리고 온 김에 뮤직비디오 찍을 때 입을 {highlight}{bold}의상 쇼핑{/bold}{/highlight}도 좀 했어요."
    
    TownCharacterSetEmot(TownCharacterGetUserOtherTown(), "Characters/Emoticon_question")
    Wait(1.5)
    
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001",STR_QUEST_TEXT(810015005))  -- "{highlight}{bold}마을마다 옷가게에서 파는 의상들이 달라서{/bold}{/highlight} 가끔 여러 마을을 돌아다니면서 쇼핑을 하곤 해요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001",STR_QUEST_TEXT(810015006))  -- "여러 아카데미나 크루의 꾸밈새를 구경도 할 겸 말이죠."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001",STR_QUEST_TEXT(810015007))  -- "[유저의 닉네임] 님도 가끔 여러 마을을 산책해보세요. 기분 전환에 그것만 한 게 없다니까요?"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001",STR_QUEST_TEXT(810015008))  -- "그럼 전 다른 마을도 들러야 해서 먼저 가볼게요. 오신 김에 천천히 구경하다 가세요."
    
    TownCameraFree()
    TownCharacterWalkTo(TownCharacterGetNPCOtherTown(0, 111), 360, 33*40-182) -- 인상 좋은 청년 화면 우측으로 걸어나감
    Wait(1.5)

	-- 퀘스트 완료, 화면 줌아웃
    TownCameraZoomOut()
    -- 마을 UI 등장
    SceneTownSetStateIdle()	
	SceneTownRefresh()
	
    -- 퀘스트 시작/완료/보상(진입 튜토리얼은 완료, 보상 팝업 안 뜸)
    QuestStart()
    QuestComplete()
    QuestReward()

    -- 진입 퀘스트 특성상 마을 배경음을 직접 플레이 시켜줌
    SoundPlayBGM(629037) --=BGM=Theme_Town
end

--유저가 타유저 마을로 가기 버튼을 누르면 타유저의 마을에 진입한 상태로 스크립트 진행(광장에서 인상 좋은 청년이 유저 캐릭터에게 다가와서 시작)
--타유저 마을에서 캐릭터 이동하는 스크립트가 작동하기 어렵다면, 캐릭터가 등장하지 않는 상태에서 진행
--이 퀘스트를 진행 가능한 상태가 되면, 타유저 마을로 가기 버튼에 new 표시(그 외의 UI에는 new 표시 안 함)
if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then
    -- 타유저 정보 화면 진입 시, 타유저 마을로 가기 버튼에 new 표시 
	if OnGameAction("OnAfterSceneEntered/SceneUserInfo") or OnGameAction("OnAfterPopupEntered/PopupTownOtherUser") then
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_003_04", "btn_visitaca", "btn_visitaca/iconNew", 35, 30)
    end	
    -- 타유저 마을로 가기 버튼 클릭 시, 타유저 마을로 가기 버튼에 new 표시 제거
    if OnGameAction("OnUIClick/SceneUserInfo/btn_visitaca") or OnGameAction("OnUIClick/PopupTownOtherUser/btn_visitaca") then
        UIRemoveNewIconWithCCB("UI_common/ui_btn2_003_04", "btn_visitaca", "btn_visitaca/iconNew")
    end
	
	-- 타유저 마을 진입 시, 퀘스트 진행 시작
	if OnGameAction("OnAfterSceneEntered/SceneTown") then
		if CheckOtherUserTown() then	
			ScriptOnQuest()
		end
	end
end



-- PRELOAD_END

if OnQuestReplay() then
  --TODO
end
