-- 악기를 마음대로(810017) -- 진입형 퀘스트
-- version("0.41.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520303)  -- 악기상점 관련 기능을 열어줌
    UnlockContents(520305)  -- 악기 추가, 편집 관련 기능을 열어줌
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
    --TODO
    return true
end

--유저가 악기 목록 화면에서 신스 선택 팝업창을 띄우면(악기추가>신서사이저, 악기수정) 그 상태에서 진행
--이 퀘스트를 진행 가능한 상태가 되면 [추가], [신서사이저](악기 추가 방식 선택 팝업창에서), [수정] 버튼에 new 표시(유저 캐릭터 바로 가기 버튼, 음악 버튼, 악기 버튼에도 new 표시)
--진입 튜토리얼의 경우, 어두운 화면에 퀘스트 제목 뜨는 과정 없음

-- PRELOAD_BEGIN

local function ScriptOnQuest()

   -- 퀘스트 시작 조건 검사
   if not CheckQuestStartReq() then
       return
   end

    -- 기존의 배경음 백업
    SoundGetDvmBase64()

   FullLoad() -- 리소스 로딩
   UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 퀘스트 배경음
   SoundPlay(9) --=BGM=Event_Quest_common

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    QuestStart()

    DialogOpen(117, STR_NPC(117), "Characters/npc_017",STR_QUEST_TEXT(810017001))  -- "아직 손때 묻지 않은 신선한 {highlight}{bold}신서사이저{/bold}{/highlight} 소리가 나서 와봤더니 너였군."
    DialogOpen(117, STR_NPC(117), "Characters/npc_017",STR_QUEST_TEXT(810017002))  -- "{highlight}{bold}신서사이저{/bold}{/highlight}를 막 사용하기 시작했나봐?"
    DialogOpen(117, STR_NPC(117), "Characters/npc_017",STR_QUEST_TEXT(810017003))  -- "그 말은 곧, 더 다채로운 {highlight}{bold}음악{/bold}{/highlight}을 만들 수 있다는 의미이지."
    DialogOpen(117, STR_NPC(117), "Characters/npc_017",STR_QUEST_TEXT(810017004))  -- "{highlight}{bold}신서사이저{/bold}{/highlight}를 사용하면 {highlight}{bold}악기{/bold}{/highlight}로 쓸 소리를 자유롭게 {highlight}{bold}만들거나 수정{/bold}{/highlight}할 수 있으니까."
    DialogOpen(117, STR_NPC(117), "Characters/npc_017",STR_QUEST_TEXT(810017005))  -- "{highlight}{bold}신서사이저{/bold}{/highlight}로 만든 소리는 만든 사람의 진심을 전달하는 힘이 있어."
    DialogOpen(117, STR_NPC(117), "Characters/npc_017",STR_QUEST_TEXT(810017006))  -- "종말을 맞을 뻔했던 우리 {highlight}{bold}춤요정{/bold}{/highlight}들이 이렇게 다시 번성하게 된 것도..."
    DialogOpen(117, STR_NPC(117), "Characters/npc_017",STR_QUEST_TEXT(810017007))  -- "{highlight}{bold}신서사이저{/bold}{/highlight}로 만든 소리가 사람들의 영혼을 울린 덕분이었다지. {highlight}{bold}초대 전설춤꾼{/bold}{/highlight}의 진심이 담긴."
    DialogOpen(117, STR_NPC(117), "Characters/npc_017",STR_QUEST_TEXT(810017008))  -- "혹시 다른 기능을 가진 {highlight}{bold}신서사이저{/bold}{/highlight}가 필요하면, 마을에서 {highlight}{bold}악기장인 이서크{/bold}{/highlight}를 찾아가봐."
    DialogOpen(117, STR_NPC(117), "Characters/npc_017",STR_QUEST_TEXT(810017009))  -- "여러 종류의 {highlight}{bold}신서사이저{/bold}{/highlight}와, 신서사이저로 만든 {highlight}{bold}악기{/bold}{/highlight}들을 팔고 있거든."

    Wait(0.5)


    QuestComplete()
    QuestReward()

    -- 백업했던 배경음 플레이하고 제거
    SoundPlayBGMBase64()
    SoundClearBase64()

    --진입 튜토리얼이 끝나면 마을로 돌아가지 않고 해당 UI에 머물러 있는 상태
end

if CheckQuestAppear() then
    -- 마을/댄스비전 진입 시, 유저 캐릭터 바로가기 버튼에 new 표시
    if OnTownRefresh() or OnGameAction("OnAfterSceneEntered/SceneDanceVision") then
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_001_01", "btn_myavt", "btn_myavt/iconNew", 29, 41)
        UIShowWithCCB( "UI_common/ui_icon_new5_main_topbar", "icon_new_ByCCB")
    end
end

if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then

    -- 내 춤꾼 팝업 생성 시, 음악 버튼에 New표시
    if OnGameAction("OnAfterPopupEntered/PopupTownUser") then
        UnlockQuestContents()
		UIAddNewIconAtWithCCB("UI_common/ui_btn2_003_05", "btn_info_music", "btn_info_music/iconNew", 29, 47)
    end

    if OnGameAction("OnAfterSceneEntered/SceneMyInfo") then
        UnlockQuestContents()
        UIAddNewIconAt("btn_info_music", "btn_info_music/iconNew1", 29, 41)
    end

    -- 음악 화면 진입 시, 악기 버튼에 New표시
    if OnGameAction("OnAfterSceneEntered/SceneMusicList") then
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_004_01", "btn_instr", "btn_instr/iconNew", 35, 31)
    end
    -- 악기 화면 진입 시, 추가 버튼과 수정 버튼에 New표시
    if OnGameAction("OnAfterSceneEntered/SceneMusicInstList") then
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_006_02", "btn_add", "btn_add/iconNew", 35, 31)
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_006_02", "btnToggle_edit_info", "btnToggle_edit_info/iconNew", 35, 31)
    end
    -- 추가 수단 선택 팝업 진입 시, 신서사이저 버튼에 New표시
    if OnGameAction("OnAfterPopupEntered/PopupMakeNewInst") then
        UIAddNewIconAtWithCCB("UI_common/ui_popup_music_select", "btn_synth", "btn_synth/iconNew", 71, 101)
    end
    -- 신서사이저 버튼이나 수정 버튼 클릭 시, 유저 캐릭터 바로가기 버튼 / 음악 버튼 / 악기 버튼 / 신서사이저 버튼 / 수정 버튼의 new 표시 제거 
    if OnGameAction("OnAfterPopupEntered/PopupSynthList") then
        UIRemoveNewIconWithCCB("UI_common/ui_btn2_001_01", "btn_myavt", "btn_myavt/iconNew")
        UIRemoveNewIconWithCCB("UI_common/ui_btn2_003_05", "btn_info_music", "btn_info_music/iconNew")
        UIRemoveNewIcon("btn_info_music", "btn_info_music/iconNew1")
        UIRemoveNewIconWithCCB("UI_common/ui_btn2_004_01", "btn_instr", "btn_instr/iconNew")
        UIRemoveNewIconWithCCB("UI_common/ui_btn2_006_02", "btn_add", "btn_add/iconNew")
        UIRemoveNewIconWithCCB("UI_common/ui_btn2_006_02", "btnToggle_edit_info", "btnToggle_edit_info/iconNew")
        UIRemoveNewIconWithCCB("UI_common/ui_popup_music_select", "btn_synth", "btn_synth/iconNew")
        UIHideWithCCB( "UI_common/ui_icon_new5_main_topbar", "icon_new_ByCCB")
        RefreshNewCount()
    end
    --  신서사이저 선택 팝업 진입 시, 퀘스트 진행 시작
    if OnGameAction("OnAfterPopupEntered/PopupSynthList") then
        ScriptOnQuest()
    end
end





-- PRELOAD_END
-- 퀘스트 다시하기
if OnQuestReplay() then
    --TODO
end
