-- 쇼핑 전야(810020) -- 스토리 퀘스트
-- version("0.52.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
end

local function CheckQuestStartReq()
    if not CheckQuestStartRequire(10001) then
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810020001))    -- "아카데미 {highlight}{bold}레벨 [start10001]{/bold}{/highlight}이 되면 다음 이야기를 볼 수 있다네. (수정 예정)"
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810020002))   -- "{highlight}{bold}아르바이트{/bold}{/highlight}는 경험치와 재화를 얻을 수 있는 좋은 수단이지. (수정 예정)"

        return false
    end

    return true
end

local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810020003))  -- "춤꾼에게 의상이 얼마나 중요한지는 잘 아시죠?"
end


local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    QuestStart()

    -- 카바네 집으로
    PushSceneScript()
    AnimationAdd("livingroom", "BG/BG_cabahome_livingroom")
    AnimationSetFullScreen("livingroom")
    AnimationAdd("table", "BG/BG_cabahome_item_table")
    -- 테이블 위에 쇼핑 목록
    AnimationAdd("shoppinglist", "BG/BG_cabahome_item_memo")
    AnimationSetPos("shoppinglist", -5, 75)
    AnimationSetPos("table", 0, -15)
    -- 샤바 배경음
    SoundPlayBGM(629057) --=BGM=Character_Shaba

    ScenarioIntroShow(103)

    -- 카트라슈 등장
    CharacterAdd(107, -180, 35)
    -- 샤바 등장
    CharacterAdd(103, 60, -160)
    -- 유저 등장
    CharacterAdd(1, -60, -160)
    Wait(1)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810020004))  -- "오랫동안 기다리셨어요!"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810020005))  -- "드디어 우리 모두가 기다리고 기다리던 쇼핑 시간이 다가오고야 말았네요!"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810020006))  -- "[유저의 닉네임] 님도 설레시죠?"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(810020007))  -- "하지만 이렇게 흥분되는 순간일수록 냉철함을 잃지 않도록 조심해야 돼요!"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810020008))  -- "그래서 전 정말 꼭 사고 싶은 것만 추려서 쇼핑 목록을 만들어요."

    -- 쇼핑 목록 애니메이션
    AnimationPlay("shoppinglist")
    SoundPlayEffect(629076) --FOCUS_SHOP
    Wait(2)

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_004", STR_QUEST_TEXT(810020009))  -- "[유저의 닉네임] 님도 이렇게 계획적인 쇼핑을 하도록 하세요."

    -- 유저 어이없음
    CharacterShowEmotion(1, "Characters/Emoticon_silly")
    Wait(1.5)

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810020010))  -- "그렇게 감탄하는 눈빛으로 쳐다보면 쑥쓰럽잖아요. 호호."
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810020011))  -- "원래 쇼핑의 내공이라는 건 하루 아침에 쌓이는 게 아니랍니다!"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810020012))  -- "그런 의미에서 오늘 저와 함께 하는 쇼핑은 아주 훌륭한 경험이 될 거에요."
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810020013))  -- "우리 모두 합리적인 소비 생활을 해보자구요!"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810020014))  -- "그럼 마음을 굳게 먹고, {highlight}{bold}옷 가게{/bold}{/highlight}로 출발!"

    -- 샤바 화면 좌측 퇴장
    CharacterWalkOut(103, -1000, -160)
    Wait(1.5)

    CharacterShowEmotion(1, "Characters/Emoticon_unanser")
    Wait(1.5)

    -- 유저 화면 좌측 퇴장
    CharacterWalkOut(1, -1000, -160)
    Wait(1.5)

    MonologOpen(STR_QUEST_TEXT(810020015))  -- "이번에는 옷가게인가..."
    Wait(2)
    MonologClose()

    -- 카트라슈 제거
    CharacterRemove(107)
    -- 샤바 제거
    CharacterRemove(103)
    -- 유저 제거
    CharacterRemove(1)
    
    ScenarioEndingShow() -- "[쇼핑 전야] 스토리 완료"
    Wait(2)
    
    -- 퀘스트 시작/완료/보상
    QuestComplete()
    QuestReward()
    GoTown()
end

-- PRELOAD_BEGIN

-- 카바네 집 앞에 샤바 서있음
if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(103), -8*40, 53*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(103))
        TownCharacterSetQuest(TownCharacterGetNPC(103))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(103)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(103))
        --DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", "춤꾼에게 의상이 얼마나 중요한지는 잘 아시죠?")
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(103)
    end

    if OnClickQuestTab(TownCharacterGetNPC(103)) then
        --DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", "춤꾼에게 의상이 얼마나 중요한지는 잘 아시죠?")
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end
end

-- PRELOAD_END

if OnQuestReplay() then
 	--TODO
end
