-- 최고의 환경에서 최고의 춤이(820005) -- 체험형 퀘스트
-- version("0.49.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520004)  -- 인테리어 샵 관련 기능을 열어줌
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO
    return true
end

local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005001))  -- "아카데미를 좀 더 예쁘게 꾸미고 싶지?"
end




local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return false
    end

    if CheckQuestManagerDummy() then
        -- 인테리어 아이템 구매 스킵 모드
        SetInteger("skip_buy_interior", 1)

    end

    -- 인테리어 아이템 구매 연출 스킵
    SetInteger("skip_eff_interior", 1)

    if CheckQuestRunning() == false then
        -- 인테리어 퀘스트의 경우 시작 시 아카데미 정보를 받아오므로, 인테리어 작업 전에 퀘스트를 시작해줘야 함
        QuestStart()
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 마을 캐릭터 모두 감추기
      -- TownCharacterHideAll()
    -- 퀘스트 배경음
    SoundPlay(67) --=BGM=Theme_Interiorshop

    -- 퀘스트 인트로
    ScenarioIntroShow(144)

    -- 인테리어 상점의 스크롤 백업값 초기화
    ResetInteriorShopScroll()

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005002))  -- "아카데미가 새로 생겼다길래 어떤 유능한 춤꾼이 맡나 했더니, 아는 얼굴이네?"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005003))  -- "맞지? 그 때 그... 하늘에서 떨어진?"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005004))  -- "벌써 아카데미를 지원해줄 정도라니 춤꾼협회에서 팍팍 밀어주기로 했나봐?"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005005))  -- "그렇다면 나도 팍팍 밀어줘야지! 크게 될 춤꾼인 것 같으니 말이야!"

    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_haha")
    Wait(1.5)

    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005006))  -- "여기로 말할 것 같으면, 잘 나가는 인테리어 물품들이 가득한 나의 인테리어 샵!"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005007))  -- "잘 찾아온 거야! 춤이나 음악 같은 창조적인 분야는 주위 환경이 잘 꾸며져 있어야 좋은 게 술술 나오는 법이니!"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005008))  -- "혹시 오해할까 봐 그러는데, 내가 지금 우리 인테리어 샵 물건이나 팔려고 그러는 게 아냐."
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005009))  -- "하필 좋은 환경을 만드는 데 적합한 물건들이 우리 가게에 있을 뿐."

    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_silly")
    Wait(1.5)

    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005010))  -- "자, 자, 당장 인테리어는 안 해도 되니까, 일단 견적부터 받아봐~"

    -- 스킵 버튼 비활성화
    RemoveQuestSkipButton()

    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005011))  -- "{highlight}{bold}인테리어 상점{/bold}{/highlight} 버튼을 살짝 눌러보겠어?"
    
    -- [인테리어 샵 주인] 캐릭터 아래에 [주문하기] 버튼 등장.
    -- 아카데미 입구 근처(초기 아카데미 모양이 확정되면 더 자세히)로 화면 이동.
    PushPopupTownInterior(144)
    
    -- [인테리어 하기] 버튼을 누르면
    ::jmp_btn_shop_interior::
    RequireButtonWithCCB("UI_common/ui_btn2_012_01", "btn_shop_interior")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005012))  -- "자, 부담 가지지 말고 {highlight}{bold}인테리어 상점{/bold}{/highlight} 버튼을 눌러봐~"
        goto jmp_btn_shop_interior
    end
    
    -- 평상시 인테리어 모드보다 카메라를 좀 더 당긴다(튜토리얼 한정)
    TownMapSetPos(TownCharacterGetNPC(0), 0, -10*40, 0.85)

    SoundPlay(67) --=BGM=Theme_Interiorshop

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005013))  -- "춤꾼협회도 참... 우리 마을을 대표하는 아카데미를 이렇게 초라하게 꾸며놓다니!"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005014))  -- "인테리어 전문가로서 이꼴을 그냥 보고만 있을 수는 없지!"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005015))  -- "내가 큰마음 먹고 이번 한번은 무료로 인테리어를 해줄게~"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005016))  -- "먼저 아카데미를 좀 넓혀야 될 것 같은데... 주위에 걸리적 거리는 게 너무 많네?"

    -- 퀘스트에서 불필요한 undo/redo버튼은 안보이게 처리, 동작하지 말아야할 골드, 댄소나이트 충전관련 버튼 비활성화처리
    UIHideWithCCB( "UI_common/ui_btn2_010_01", "btn_undo")
    UIHideWithCCB( "UI_common/ui_btn2_010_01", "btn_redo")
    UIDisableWithCCB( "UI_common/ui_main_top_02", "btn_add_gold")
    UIDisableWithCCB( "UI_common/ui_main_top_02", "btn_add_dsn")

    -- 스킵 버튼 비활성화
    RemoveQuestSkipButton()

    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005017))  -- "먼저 아카데미 주위의 나무 같은 {highlight}{bold}장애물{/bold}{/highlight}들을 좀 {highlight}{bold}제거{/bold}{/highlight}해야겠어!"

    TownMapSetPos(TownCharacterGetNPC(0), -12*40, -11*40, 0.85)  --확장할 공간을 중심으로 줌인(튜토리얼 한정)
      --아카데미 왼쪽 하단 벽 바깥쪽 4 X 3 지점을 중심으로 화면 줌인
      --아카데미 왼쪽 하단 벽 바깥쪽 4 X 3 영역 안에 있는 장애물들을 빨간색으로 표시(아이템 설치 불가 표시와 동일한 방식)
    
    DescriptionBarShow(STR_QUEST_TEXT(820005018))  -- "붉은 박스 안의 나무를 터치해 제거해보세요."

--############################################################################################
    --화면 스크롤과 정해진 영역 안의 장애물 제거 외에 다른 조작은 금지
    --정해진 영역 안의 장애물 제거가 완료되면 아래의 스크립트 진행
    ::jmp_clean_obstacle4x3::
    RequireSceneTownRemoveObstacleInArea(-15, -7, -16, -5)
    if RequireCheckResult("OutOfTouch") then
        goto jmp_clean_obstacle4x3
    end
--############################################################################################

    DescriptionBarHide()
    
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005019))  -- "바닥 장식도 방해가 되니 좀 치워야겠는데?"
    
    --4 X 3 영역 안에 있는 바닥 장식들을 빨간색으로 표시(아이템 설치 불가 표시와 동일한 방식)
    
    DescriptionBarShow(STR_QUEST_TEXT(820005020))  -- "붉은 박스 안의 아이템을 터치해 판매/보관해보세요."

--############################################################################################
    --화면 스크롤과 정해진 영역 안의 바닥 장식을 판매/보관하는 것 외 다른 조작은 금지
    --정해진 영역 안의 바닥 장식을 판매/보관해서 제거하는 작업이 완료되면 아래의 스크립트 진행
    ::jmp_clean_floor4x3::
    RequireSceneTownRemoveFloorAccInArea(-15, -7, -16, -5)
    if RequireCheckResult("OutOfTouch") then
        goto jmp_clean_floor4x3
    end
--############################################################################################

    DescriptionBarHide()

    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005021))  -- "이제 깨끗하게 정리가 됐으니 아카데미를 확장해볼까?"

    Wait(0.5)
    UIShowWithCCB("UI_common/ui_btn2_010_01", "btn_interior1")
    UIShowWithCCB("UI_common/ui_btn2_010_01", "btn_interior2")
    UIShowWithCCB("UI_common/ui_btn2_010_01", "btn_interior3")
    Wait(0.5)

    ::jmp_btn_interior1::
    RequireButtonWithCCB("UI_common/ui_btn2_010_01", "btn_interior1")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005022))  -- "걱정하지 말고 눌러봐~ 내가 언제 바가지 씌우는 거 봤어?"
        goto jmp_btn_interior1
    end
    
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005023))  -- "아카데미 벽 구조를 바꾸려면 {highlight}{bold}벽 설치{/bold}{/highlight} 버튼을 누르면 돼~"
    
    ::jmp_btnWallOuter::
    RequireButton("WallItem")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005024))  -- "{highlight}{bold}벽 설치{/bold}{/highlight}을 이용해서 아카데미 벽의 구조를 바꿀 수 있어."
        goto jmp_btnWallOuter
    end
    
    ::jmp_btnPlaceItem_WallOuter::
    RequireButtonWithCCB("UI_common/ui_btn2_010_02", "btn_ok")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005024))  -- "{highlight}{bold}벽 설치{/bold}{/highlight}을 이용해서 아카데미 벽의 구조를 바꿀 수 있어."
        goto jmp_btnPlaceItem_WallOuter
    end

    SoundPlay(67) --=BGM=Theme_Interiorshop

    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001",STR_QUEST_TEXT(820005025))  -- "벽 설치는 너무 간단해서 설명도 필요없을 정도야."
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001",STR_QUEST_TEXT(820005026))  -- "벽을 원하는 곳에다가 끌어다가 V 모양 버튼만 누르면 설치 완료!"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001",STR_QUEST_TEXT(820005027))  -- "요 간단한 조작으로 아카데미 벽 구조를 바꿀 수 있다는 사실에 감탄한 기색이 역력하네~"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001",STR_QUEST_TEXT(820005028))  -- "그럼 본격적으로 벽을 설치해볼까?"

    -- 벽을 설치할 위치(첨부 그림의 1번)에 표시(기존의 아카데미 확장 가능 표시와 같은 색)

    DescriptionBarShow(STR_QUEST_TEXT(820005029))  -- "표시된 지역에 벽을 설치해보세요."



    -- 진행조건 : 지정된 위치에 벽 설치
    -- X 버튼은 등장하지 않음, 지정된 위치 이외의 장소에서는 설치 버튼 비활성화 상태
    SetSceneTownInstallWallMark( -8, -7, -8, -7)
    ::jmp_wall_step1::
    RequireSceneTownInstallWall( -8, -7, -8, -7)
    if RequireCheckResult("OutOfTouch") then
        goto jmp_wall_step1
    end
    ClearSceneTownInstallWallMark()

    DescriptionBarHide()
    
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001",STR_QUEST_TEXT(820005030))  -- "간단하지? 같은 방식으로 벽을 쭉 설치하면 돼~"

    ::jmp_btnInterEditCancel::
    RequireButtonWithCCB("UI_common/ui_btn2_inter_edit_01", "inter_edit_cancel")
    if RequireCheckResult("OutOfTouch") then
        goto jmp_btnInterEditCancel
    end

    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001",STR_QUEST_TEXT(820005031))  -- "나머지 벽은 내가 빠른 속도로 설치해 주지!"
    
    -- 나머지 벽을 모두 자동으로 설치(벽 철거 튜토리얼에서 구현된 자동 벽 철거처럼 하나씩 차례차례 설치됨)
    wall_install_delay = 0.4

    for i = 0, 6, 1 do
        AutoInstallSceneTownPlaceWall( -9 - i, -8)
        Wait( wall_install_delay)
    end

    for i = 0, 6, 1 do
        AutoInstallSceneTownPlaceWall( -15, -9 - i)
        Wait( wall_install_delay)
    end

    for i = 0, 6, 1 do
        AutoInstallSceneTownPlaceWall(-14 + i, -15)
        Wait( wall_install_delay)
    end

    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001",STR_QUEST_TEXT(820005032))  -- "어때? 건물이 그럴싸하게 넓어졌지?"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001",STR_QUEST_TEXT(820005033))  -- "이제 새로 넓힌 공간이랑 원래 있던 공간을 막고 있는 벽만 철거하면 되겠군!"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001",STR_QUEST_TEXT(820005034))  -- "벽 철거는 더 간단해. 철거할 벽을 누르고 철거 버튼만 되거든."

    if CheckTownEditWall(-7, -6, -9, -8) then
        -- 첨부 그림의 2번 위치에 있는 벽을 터치하도록 유도

        tx = (4 * 40) + 25
        ty = 3 * 40

        --AddUIObject("wall", tx - 50, tx + 50, ty - 50, ty + 50);
        AddUIObject("wall", tx, ty, 40, 40);
        ::jmp_click1::
        RequireClick("wall")
        if RequireCheckResult("OutOfTouch") then
            DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001",STR_QUEST_TEXT(820005035))  -- "철거할 벽을 터치해봐~"
            goto jmp_click1
        end
        RemoveUIObject("wall")

        ShowTownEditWall( -7, -6, -9, -8)

        -- 철거 버튼을 누르도록 유도
        ::jmp_click2::
        RequireButtonWithCCB("UI_common/ui_btn2_inter_edit_01", "inter_edit_del")
        if RequireCheckResult("OutOfTouch") then
            DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001",STR_QUEST_TEXT(820005036))  -- "철거 버튼을 터치해봐~"
            goto jmp_click2
        end
    end

    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001",STR_QUEST_TEXT(820005037))  -- "이런 식으로 필요없는 벽을 없애면 되는 거야~"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001",STR_QUEST_TEXT(820005038))  -- "더 해보라고 하면 귀찮아할 테니 나머지 벽 제거는 능숙한 내가 샤라락!"
    
    -- 확장된 공간과 기존 공간을 가로막고 있던 다른 벽을 자동으로 제거
    RemoveSceneTownPlaceWalls( -7, -6, -14, -8)
    Wait(3)
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005039))  -- "아카데미가 넓어지니 내 속이 다 시원하네~"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005040))  -- "그런데... 바닥이 너무 바깥이랑 똑같..."
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005041))  -- "깔끔하고 품격있는 바닥재를 쫙 깔아서 분위기를 좀 바꿔보는 게 좋겠어!"

    Wait(0.5)
    UIShowWithCCB("UI_common/ui_btn2_010_01", "btn_interior1")
    UIShowWithCCB("UI_common/ui_btn2_010_01", "btn_interior2")
    UIShowWithCCB("UI_common/ui_btn2_010_01", "btn_interior3")
    Wait(0.5)

    ::jmp_btnbtnPlaceBackPaper0::  --뒤로 가기 버튼을 누르도록 유도
    RequireButtonWithCCB("UI_common/ui_btn2_010_01", "btn_interior1")  --뒤로 가기 버튼을 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005042))  -- "{highlight}{bold}바닥재{/bold}{/highlight}가 뭐냐에 따라 실내 분위기가 확 바뀐다니까?"
        goto jmp_btnbtnPlaceBackPaper0  --뒤로 가기 버튼을 누르도록 유도
    end

    ::jmp_btnTabFloorCovering::
    RequireButton("btnTabFloorCovering")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005042))  -- "{highlight}{bold}바닥재{/bold}{/highlight}가 뭐냐에 따라 실내 분위기가 확 바뀐다니까?"
        goto jmp_btnTabFloorCovering
    end


    UIListScrollTo("uiItemListFloorCovering", "btnItem11020013")
    UIListScrollLock( "uiItemListFloorCovering", 1)

    ::jmp_btnItem11020013::  --고동색 줄무늬 바닥재 누르도록 유도
    RequireButton("btnItem11020013")  --고동색 줄무늬 바닥재 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005042))  -- "{highlight}{bold}바닥재{/bold}{/highlight}가 뭐냐에 따라 실내 분위기가 확 바뀐다니까?"
        goto jmp_btnItem11020013  --고동색 줄무늬 바닥재 누르도록 유도
    end
    UIListScrollLock( "uiItemListFloorCovering", 0)

    ::jmp_btnPlaceItem_FloorCovering::  --설치 버튼 누르도록 유도
    RequireButtonWithCCB("UI_common/ui_btn2_010_02", "btn_ok")  --설치 버튼 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005042))  -- "{highlight}{bold}바닥재{/bold}{/highlight}가 뭐냐에 따라 실내 분위기가 확 바뀐다니까?"
        goto jmp_btnPlaceItem_FloorCovering  --설치 버튼 누르도록 유도
    end

    SoundPlay(67) --=BGM=Theme_Interiorshop

    DescriptionBarShow(STR_QUEST_TEXT(820005043))  -- "붉은 박스 안의 바닥을 손가락으로 문질러보세요."
--############################################################################################
      --새로 확장된 공간의 바닥이 반짝임
      --화면 스크롤과 확장된 공간의 바닥에 바닥재를 설치하는 것 외의 조작은 막음
      --유저가 바닥재 설치 작업을 마치면 아래의 스크립트 진행
    ::jmp_FloorCovering_install::
    RequireSceneTownFloorCoveringInstall(-14, -6, -14, -8)
    if RequireCheckResult("OutOfTouch") then
    goto jmp_FloorCovering_install
    end
--############################################################################################

    DescriptionBarHide()

    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005044))  -- "휴, 이렇게 하니 실내같은 느낌이 드네~"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005045))  -- "이제 디테일만 좀 잡으면 될 것 같은데..."
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005046))  -- "일단 창작욕구가 마구 솟구치도록 {highlight}{bold}벽{/bold}{/highlight}을 알록달록 꾸미는 게 좋을 것 같은데?"
    

    ::jmp_btnBuildBack1::  --뒤로 가기 버튼 누르도록 유도
    RequireButtonWithCCB("UI_common/ui_btn2_010_01", "btn_backward")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005047))  -- "{highlight}{bold}벽지{/bold}{/highlight}가 심리 상태에 얼마나 큰 영향을 주는지 알지?"
        goto jmp_btnBuildBack1
    end

    ::jmp_btnTabWallPaper::
    RequireButton("btnTabWallPaper")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005047))  -- "{highlight}{bold}벽지{/bold}{/highlight}가 심리 상태에 얼마나 큰 영향을 주는지 알지?"
        goto jmp_btnTabWallPaper
    end


    UIListScrollTo("uiItemListWallPaper", "btnItem11010021")
    UIListScrollLock( "uiItemListWallPaper", 1)

    ::jmp_btnItem11010021::  --알록달록 벽지 누르도록 유도, 알록달록 벽지가 목록의 앞부분에 있을 필요
    RequireButton("btnItem11010021") --알록달록 벽지 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005047))  -- "{highlight}{bold}벽지{/bold}{/highlight}가 심리 상태에 얼마나 큰 영향을 주는지 알지?"
        goto jmp_btnItem11010021  --알록달록 벽지 누르도록 유도
    end
    UIListScrollLock( "uiItemListWallPaper", 0)

    ::jmp_btnPlaceItem_WallPaper::  --설치 버튼 누르도록 유도
    RequireButtonWithCCB("UI_common/ui_btn2_010_02", "btn_ok")  --설치 버튼 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005047))  -- "{highlight}{bold}벽지{/bold}{/highlight}가 심리 상태에 얼마나 큰 영향을 주는지 알지?"
        goto jmp_btnPlaceItem_WallPaper  --설치 버튼 누르도록 유도
    end

    SoundPlay(67) --=BGM=Theme_Interiorshop

    DescriptionBarShow(STR_QUEST_TEXT(820005048))  -- "붉은 박스 안의 벽을 손가락으로 문질러보세요."

--############################################################################################
      --새로 확장된 공간의 안쪽 벽이 반짝임
      --화면 스크롤과 새로 확장된 공간의 안쪽 벽에 벽지를 바르는 것 외의 조작은 막음
      --유저가 벽지 바르는 작업을 마치면 아래의 스크립트 진행
    ::jmp_wallpaper_install::
    RequireSceneTownWallPaperInstall(-14, -6, -8, -6)
    if RequireCheckResult("OutOfTouch") then
        goto jmp_wallpaper_install
    end
--############################################################################################
    BeginTimeTouchLock( 0.5)

    DescriptionBarHide()
    
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005049))  -- "어머~ 화사하기도 해라~"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005050))  -- "공짜로 해주는 거니 내 취향에 좀 맞춰도 상관없지? 호호~"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005051))  -- "이제 음악을 빵빵하게 틀어줄 아이템만 하나 딱 두면 완벽하겠어~"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005052))  -- "그럼 마지막으로 스피커 빵빵한 오디오도 하나 기증하도록 하지!"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005053))  -- "정말... 나의 서비스 정신이란... 나도 깜짝깜짝 놀라곤 해~"

    ::jmp_btnPlaceBackFloor0::  --뒤로 가기 버튼을 누르도록 유도
    RequireButtonWithCCB("UI_common/ui_btn2_010_01", "btn_backward")  --뒤로 가기 버튼을 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005054))  -- "스피커 빵빵한 오디오도 하나 기증하도록 하지!"
        goto jmp_btnPlaceBackFloor0  --뒤로 가기 버튼을 누르도록 유도
    end


    ::jmp_btnBackScene0::  --뒤로 가기 버튼을 누르도록 유도
    RequireButtonWithCCB("UI_common/ui_btn2_010_02", "btn_backward")  --뒤로 가기 버튼을 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005054))  -- "스피커 빵빵한 오디오도 하나 기증하도록 하지!"
        goto jmp_btnBackScene0  --뒤로 가기 버튼을 누르도록 유도
    end

    SoundPlay(67) --=BGM=Theme_Interiorshop

    Wait(0.5)
    UIShowWithCCB("UI_common/ui_btn2_010_01", "btn_interior1")
    UIShowWithCCB("UI_common/ui_btn2_010_01", "btn_interior2")
    UIShowWithCCB("UI_common/ui_btn2_010_01", "btn_interior3")
    Wait(0.5)

    ::jmp_btn_interior2::
    RequireButtonWithCCB("UI_common/ui_btn2_010_01", "btn_interior2")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005054))  -- "스피커 빵빵한 오디오도 하나 기증하도록 하지!"
        goto jmp_btn_interior2
    end

    ::jmp_btnTabFurniture::
    RequireButton("btnTabFurniture")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005054))  -- "스피커 빵빵한 오디오도 하나 기증하도록 하지!"
        goto jmp_btnTabFurniture
    end


    UIListScrollTo("uiItemListFurniture", "btnItem12000072")
    UIListScrollLock( "uiItemListFurniture", 1)

    ::jmp_btnItem12000072::  --스피커빵빵 오디오 누르도록 유도
    RequireButton("btnItem12000072")  --스피커빵빵 오디오 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        goto jmp_btnItem12000072  --스피커빵빵 오디오 누르도록 유도
    end
    UIListScrollLock( "uiItemListFurniture", 0)


    --[배치] 버튼에 유도 신호.
    ::jmp_btnPlaceItem_Electronic::
    UIListScrollLock("uiList", 1) -- 1 : Lock , 0 : Unlock
    RequireButtonWithCCB("UI_common/ui_btn2_010_02", "btn_ok")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005054))  -- "스피커 빵빵한 오디오도 하나 기증하도록 하지!"
        goto jmp_btnPlaceItem_Electronic
    end

    SoundPlay(67) --=BGM=Theme_Interiorshop

    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005055))  -- "이제 오디오를 원하는 장소로 옮기고 {highlight}{bold}V{/bold}{/highlight}모양의 {highlight}{bold}배치{/bold}{/highlight} 버튼만 누르면 끝!"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005056))  -- "어디에 둘까?"
    
    DescriptionBarShow(STR_QUEST_TEXT(820005057))  -- "선택한 물건을 원하는 곳에 배치해보세요."

    -- 진행조건 : 가구 배치
    RequireSceneTownPlaceOk()

    DescriptionBarHide()
    
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005058))  -- "배치를 해 놓고 보니 진열된 걸 봤을 때보다도 훨씬 더 만족스럽지?"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005059))  -- "이렇게 마음에 꼭 드는 물건은 바로 사면 끝!  물론 이번에는 그냥 주는 거지만~"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005060))  -- "{highlight}{bold}X{/bold}{/highlight} 모양의 버튼을 눌러봐."
    
    -- 진행조건 : X 눌러 배치 완료
    ::jmp_btnItemPlaceBack::
    RequireButtonWithCCB("UI_common/ui_btn2_inter_edit_01", "inter_edit_cancel")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005061))  -- "인테리어 비용을 정산하러 가보자고."
        goto jmp_btnItemPlaceBack
    end

    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005062))  -- "저기 아래에 보면 {highlight}{bold}완료{/bold}{/highlight} 버튼이 있을 거야. 현재 인테리어를 확정하려면 그걸 누르면 돼."

    -- 정산화면으로
    ::jmp_btn_buy::
    RequireButtonWithCCB("UI_common/ui_btn2_010_01", "btn_buy")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005063))  -- "그래! 이제 {highlight}{bold}완료{/bold}{/highlight} 버튼만 누르면 돼!"
        goto jmp_btn_buy
    end

    Wait(0.5)

    -- 정산 화면
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005064))  -- "거래에 실수가 있어서는 안 되니! 다시 한 번 인테리어 목록과 금액을 확인해보시고~"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005065))  -- "마음의 준비가 되었으면 {highlight}{bold}주문하기{/bold}{/highlight} 버튼만 살짝 눌러볼까?"

    -- 진행조건 : 정산하기
    ::jmp_btnBillOk::
    RequireTownInteriorBuy()
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005066))  -- "자 이제 마음의 준비가 됐지? 그럼 {highlight}{bold}주문하기{/bold}{/highlight} 버튼을 눌러보자고."
        goto jmp_btnBillOk
    end
    SetQuestProgressComplete_Dummy(10108)

    -- 앞에서 숨김, 비활성화 처리한 버튼들 복구
    UIShowWithCCB( "UI_common/ui_btn2_010_01", "btn_undo")
    UIShowWithCCB( "UI_common/ui_btn2_010_01", "btn_redo")
    UIEnableWithCCB( "UI_common/ui_main_top_02", "btn_add_gold")
    UIEnableWithCCB( "UI_common/ui_main_top_02", "btn_add_dsn")
    

    --인테리어(택배) 연출 생략하고 아카데미 입구에 유저 캐릭터와 인테리어 샵 주인이 화면 상단에 등장한 상태로 다음 스크립트 진행.
    --줌인 정도는 화면 상단에는 두 캐릭터가, 화면 하단에는 새로 확장한 공간이 보일 정도로

    -- 만일 더미 마을 데이터를 사용중이라면 복구시켜준다.
    RestoreDummyTown()

    QuestComplete()
    return true
end



local function ScriptOnQuestComplete()
    -- 퀘스트 배경음
    SoundPlay(67) --=BGM=Theme_Interiorshop

    -- 인테리어 팝업 나오지 않는 상태로.
    SceneTownSetStateEmpty()

    TownCharacterStandAt(TownCharacterAddNPC(144), -1*40, -8*40)
    TownCameraZoomIn(TownCharacterGetNPC(144), 40, 50, 2)
    ScriptTownMoveToRightSide(TownCharacterGetNPC(144))

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005067))  -- "야~ 아카데미 전체 분위기가 확 사네! 살아!"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005068))  -- "인테리어 안목이 아주 좋은데? 아, 내가 추천해준 거였나? 호호~"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005069))  -- "언제든지 아카데미 인테리어를 바꾸고 싶으면 내 샵으로 오라고~"
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005070))  -- "최고의 환경에서 비로소 최고의 춤이 나오는 법이니까 자주자주 들러줘~"

    -- 독백, 퀘스트 완료
    -- MonologOpen("")
    Wait(1)
    ScenarioEndingShow() -- "[최고의 환경에서 최고의 춤이!] 퀘스트 완료"

    QuestReward()
    GoTown()
end

local ScriptOnQuestAppear = ScriptOnQuest

local function ScriptOnQuestRunning()
-- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return false
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    if CheckQuestProgress(10108, 1) then
        SceneTownSetStateEmpty() 
        QuestComplete()
        return true
    end

    return ScriptOnQuest()
end

-- PRELOAD_BEGIN

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(144), -34*40, 14*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(144))
        TownCharacterSetQuest(TownCharacterGetNPC(144))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(144)) then
        PreLoad()
        ScriptTownMoveToInterior(TownCharacterGetNPC(144), TownCharacterGetUser())
        --DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005073))  -- "아카데미를 좀 더 예쁘게 꾸미고 싶지?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(144)
    end

    if OnClickQuestTab(TownCharacterGetNPC(144)) then
        --DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005073))  -- "아카데미를 좀 더 예쁘게 꾸미고 싶지?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        if ScriptOnQuestAppear() then
            ScriptOnQuestComplete()
        end
    end

elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(144), -34*40, 14*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(144))
        TownCharacterSetQuest(TownCharacterGetNPC(144))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(144)) then
        PreLoad()
        ScriptTownMoveToInterior(TownCharacterGetNPC(144), TownCharacterGetUser())
        --DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005073))  -- "아카데미를 좀 더 예쁘게 꾸미고 싶지?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(144)
    end

    if OnClickQuestTab(TownCharacterGetNPC(144)) then
        --DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005073))  -- "아카데미를 좀 더 예쁘게 꾸미고 싶지?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        if ScriptOnQuestRunning() then
            ScriptOnQuestComplete()
        end
    end

elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(144), -34*40, 14*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(144))
        TownCharacterSetQuest(TownCharacterGetNPC(144))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(144)) then
        PreLoad()
        ScriptTownMoveToInterior(TownCharacterGetNPC(144), TownCharacterGetUser())
        --DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005073))  -- "아카데미를 좀 더 예쁘게 꾸미고 싶지?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(144)
    end

    if OnClickQuestTab(TownCharacterGetNPC(144)) then
        --DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(820005073))  -- "아카데미를 좀 더 예쁘게 꾸미고 싶지?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuestComplete()
    end

end

-- PRELOAD_END

if OnQuestReplay() then
 	--TODO
end

