-- 아무나 오는 클럽이 아니야(820017) -- 진입형 퀘스트
-- version("0.42.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520012)  -- 춤꾼 영입 기능을 열어줌
end

--유저가 린을 터치해서 줌인한 후 [영입] 버튼 누르면 진행(영입 확인 팝업을 띄우지 않고 캐릭터 줌인 상태에서 진행)
--이 퀘스트를 진행 가능한 상태가 되면, 린이 클럽 안의 지정된 장소에서 아주 눈에 띄는 동작으로 파닥거림(유저에게 나를 봐달라는 느낌으로), [영입] 버튼에 NEW 표시
--진입 튜토리얼의 경우, 어두운 화면에 퀘스트 제목 뜨는 과정 없음


-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO
    return true
end


local function ScriptOnQuest()
    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
    QuestStart()

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(30) --=BGM=Character_DJ

    ScriptTownMoveToLeftSide(TownCharacterGetNPC(603))

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(603, STR_NPC(603), "", STR_QUEST_TEXT(820017001))  -- "앗! [유저의 닉네임] 님!"
    DialogOpen(603, STR_NPC(603), "", STR_QUEST_TEXT(820017002))  -- "이 클럽에 오시다니... 역시 춤을 진정으로 사랑하시는 게 틀림 없군요!"

    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_question")
    Wait(1.5)

    DialogOpen(153, STR_NPC(153), "", STR_QUEST_TEXT(820017003))  -- "아직 이 클럽이 어떤 곳인지 잘 모르시는 모양이군요."
    
      --유저 캐릭터를 중심으로 3명을 줌인할 수 있을 정도로 카메라 줌인/위치 조정
    TownCameraZoomIn(TownCharacterGetNPC(1), 0, 50, 1.5)

      -- 춤바람 난 사내가 화면 왼쪽에서 걸어들어와 유저의 옆에서 멈춤
    TownCharacterStandAtCharacter(TownCharacterAddNPC(153), TownCharacterGetUser(), -5*40, 0*40)
    TownCharacterWalkToCharacter(TownCharacterGetNPC(153),TownCharacterGetNPC( 1), -2*40, 0*40)
    Wait(1.5)
    
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820017004))  -- "이 클럽의 DJ는 취향이 워낙 독특해서 항상 괴상한 음악을 틀어요."
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820017005))  -- "그러니 어떤 상황에서도 춤을 추고야 마는 진정한 춤꾼들만이 이 {highlight}{bold}클럽{/bold}{/highlight}을 찾게 되는 것이죠."
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820017006))  -- "이 클럽의 음악에 맞춰 능란하게 춤을 출 정도가 되면 진정한 춤의 고수가 된다는 전설이 있을 정도라, 수련을 위해 오는 사람도 있구요."
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820017007))  -- "댄스빌 사람들은 모두 항상 춤을 추는 진정한 춤꾼들이 아니냐구요?"
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820017008))  -- "여기 사람들이 모두 춤밖에 모르는 것 같아 보이지만, 아니에요. 가짜 춤꾼들이 수두룩하거든요."
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820017009))  -- "다른 사람들이 춤을 추니까 별 생각 없이 몸을 흔들어대기만 하는 이들에게 {highlight}{bold}춤꾼{/bold}{/highlight}이라는 단어조차 아깝죠."
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820017010))  -- "저는 말이에요, 잠을 자는 시간에도 춤을 추지 못한다는 사실이 너무 안타까워요."
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820017011))  -- "그래서 항상 춤을 갈망하는 내 영혼에 사과를 하고 잠자리에 들죠."
    
    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_sweat")
    Wait(1.5)
    
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820017012))  -- "비록 저만큼은 아니지만, 이 클럽에 있는 춤꾼들은 기본적으로 춤에 대한 열정 하나는 믿으셔도 돼요."
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820017013))  -- "특히 여기 계시는 {highlight}{bold}린{/bold}{/highlight} 님은 화장실에서 볼 일을 볼 때마저 춤을 출 정도로 춤을 사랑하신다고..."
    
    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_shocking")
    Wait(1.5)

    DialogOpen(603, STR_NPC(603), "", STR_QUEST_TEXT(820017014))  -- "[유저의 닉네임] 님의 열정과 실력에 비하면 부끄러운 수준이죠..."
    DialogOpen(603, STR_NPC(603), "", STR_QUEST_TEXT(820017015))  -- "괜찮으시다면… 절 [유저의 닉네임] 님의 아카데미 일원으로 받아주시면 안 될까요...?"
    DialogOpen(603, STR_NPC(603), "", STR_QUEST_TEXT(820017016))  -- "[유저의 닉네임] 님의 {highlight}{bold}크루{/bold}{/highlight}가 되어 열심히 도울 수 있는데..."
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820017017))  -- "{highlight}{bold}린{/bold}{/highlight} 님 같은 훌륭한 춤꾼이 자발적으로 크루가 되려고 하다니!"
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820017018))  -- "{highlight}{bold}린{/bold}{/highlight} 님이라면 [유저의 닉네임] 님의 아카데미에 큰 도움이 될 거에요!"
    
    -- 영입 팝업창 등장(비용은 0으로 표시)
    -- "[춤꾼3] 춤꾼을 아카데미의 일원으로 받아들이시겠어요?"
    -- 영입 버튼에 손가락으로 누르기 유도
    SetQuestProgressComplete_Dummy(10121)
    PushPopupHireDancerYesNo(603)
    ::jmp_btnPopupYes::
    RequireButtonWithCCB("UI_common/ui_popup_buy_01", "btn_ok")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(603, STR_NPC(603), "", STR_QUEST_TEXT(820017019))  -- "꼭 함께하고 싶어요..."
        goto jmp_btnPopupYes
    end

    -- 유저가 [영입] 버튼을 누르면 아래의 팝업창 등장
    -- "[춤꾼3] 춤꾼이 아카데미의 일원이 되었습니다!"
    --PushPopupHireDancerOk(603)
    ::jmp_btnPopupOk::
    RequireClick("btnPopupOk")
    if RequireCheckResult("OutOfTouch") then
        goto jmp_btnPopupOk
    end
    SceneTownSetStateEmpty()

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(603, STR_NPC(603), "", STR_QUEST_TEXT(820017020))  -- "우왓! 이런 영광이! 감사합니다!"
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820017021))  -- "{highlight}{bold}린{/bold}{/highlight} 님을 이렇게 쉽게 데려가시다니!"
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820017022))  -- "[유저의 닉네임] 님의 명성과 실력이라면 앞으로도 이 {highlight}{bold}클럽{/bold}{/highlight}에서 많은 {highlight}{bold}춤꾼들을 영입{/bold}{/highlight}하실 수 있을 거에요."
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820017023))  -- "저도 데려가시고 싶겠지만 참아주시길. 전 춤 외에 그 어떤 것에도 얽매이고 싶지 않으니까요."
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820017024))  -- "보이지 않지만 멀지 않은 곳에서, 진정한 춤꾼의 앞날을 응원하고 있을게요."

    Wait(1)
    ScenarioEndingShow() 
    TownMapSetPos(TownCharacterGetNPC(603), 0, 50, 0.5)


    QuestComplete()
    QuestReward() -- 확인용
    GoTown()
end


local function ScriptOnQuestRunning()
	    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
	
	if CheckQuestProgress( 10121, 1) then
        SceneTownSetStateEmpty()
		DialogOpen(603, STR_NPC(603), "", STR_QUEST_TEXT(820017020))  -- "우왓! 이런 영광이! 감사합니다!"

		Wait(1)
		ScenarioEndingShow() 
		TownMapSetPos(TownCharacterGetNPC(603), 0, 50, 0.5)

		QuestComplete()
		QuestReward() -- 확인용
		GoTown()
		return
	end
	
	ScriptOnQuest()
end


-- PRELOAD_BEGIN

  --린이 클럽 안의 지정된 장소에서 파닥거리고 있음
if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterHideClubDancers()  -- 린 잘보이게 클럽 춤꾼들은 가림
        TownCharacterStandAtAndFixed(TownCharacterAddNPC(603), 35*40, 16*40)
        TownCharacterSetQuest(TownCharacterGetNPC(603))
        TownCharacterSetDanceIdle(TownCharacterGetNPC(603), 610002) -- 파닥파닥
        TownCharacterSetIconSetTimeStamp(TownCharacterGetNPC(603), "DANCER_TALK")
    end

    if OnTownCharacterClick(TownCharacterGetNPC(603)) then
        -- 캐릭터 클릭 시 클럽 춤꾼 팝업을 띄우고 영입 버튼에 new
        ScriptTownZoomInCharacter(TownCharacterGetNPC(603))
        UnlockQuestContents()
        DialogOpen(603, STR_NPC(603), STR_NPC_IMG(603, 1), STR_FOLLOWER_DIALOG(603, 610))
        PushPopupTownClubDancer(603)
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_003_03", "btn_folladd", "btn_folladd/iconNew", 35, 30)
    end

    -- 영입 버튼 클릭 시
    if OnGameAction("OnBlockUIClick/PopupTownClubDancer/btn_folladd") then
        UIRemoveNewIconWithCCB("UI_common/ui_btn2_003_03", "btn_folladd", "btn_folladd/iconNew")
        ScriptOnQuest()
    end

end

if CheckQuestRunning() or CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterHideClubDancers()  -- 린 잘보이게 클럽 춤꾼들은 가림
        TownCharacterStandAtAndFixed(TownCharacterAddNPC(603), 35*40, 16*40)
        TownCharacterSetQuest(TownCharacterGetNPC(603))
        TownCharacterSetDanceIdle(TownCharacterGetNPC(603), 610002) -- 파닥파닥
        TownCharacterSetIconSetTimeStamp(TownCharacterGetNPC(603), "DANCER_TALK")
    end

    if OnTownCharacterClick(TownCharacterGetNPC(603)) then
        -- 캐릭터 클릭 시 클럽 춤꾼 팝업을 띄우고 영입 버튼에 new
        ScriptTownZoomInCharacter(TownCharacterGetNPC(603))
        UnlockQuestContents()
        DialogOpen(603, STR_NPC(603), STR_NPC_IMG(603, 1), STR_FOLLOWER_DIALOG(603, 610))
        PushPopupTownClubDancer(603)
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_003_03", "btn_folladd", "btn_folladd/iconNew", 35, 30)
    end

    -- 영입 버튼 클릭 시
    if OnGameAction("OnBlockUIClick/PopupTownClubDancer/btn_folladd") then
        UIRemoveNewIconWithCCB("UI_common/ui_btn2_003_03", "btn_folladd", "btn_folladd/iconNew")
        ScriptOnQuestRunning()
    end
end


-- PRELOAD_END
