  -- 누군가의 스타, 누군가의 팬(820020) -- 진입 퀘스트
-- version("0.40.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520008)  -- 스타/팬 관리 기능을 열어줌
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
      --TODO
    return true
end


-- PRELOAD_BEGIN

--유저가 [춤꾼들] 버튼을 누르면 [춤꾼들] 화면 내부에 진입한 상태(스타 탭이 선택된 상태)로 스크립트 진행
--이 퀘스트를 진행 가능한 상태가 되면, [춤꾼들] 버튼에 new 표시(유저 캐릭터 바로 가기 버튼에도 new 표시)

local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    -- 기존의 배경음 백업
    SoundGetDvmBase64()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    QuestStart()

    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020001))  -- "그래요... 그런 적이 있었죠..."
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020002))  -- "가슴 한구석의 허전함이 익숙했던 시절이..."
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020003))  -- "이불 밖에서는 결코 살아남지 못할 거라 생각했던 그 시절..."
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020004))  -- "하지만 이제 완전히 다시 태어났어요."
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020005))  -- "글쎄, {highlight}{bold}댄스비전{/bold}{/highlight}에 뮤직비디오를 올려놓으니 저에게도 {highlight}{bold}팬{/bold}{/highlight}이 생기더라구요!"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020006))  -- "이제 전 혼자가 아니에요! 누군가 항상 제 춤과 음악을 기다리고 있으니까요!"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020007))  -- "{highlight}{bold}팬{/bold}{/highlight}은 만드는 것보다 관리하는 게 훨씬 더 중요하다는 건 알고 계시죠?"

    -- 스킵 버튼 비활성화
    RemoveQuestSkipButton()

    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020008))  -- "수가 적을 때부터 미리미리 교류하면 그 {highlight}{bold}스타-팬{/bold}{/highlight}은 평생 가는 거에요!"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020009))  -- "뵌 김에 {highlight}{bold}팬{/bold}{/highlight}을 {highlight}{bold}관리{/bold}{/highlight}하는 노하우를 전수해드릴게요!"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020010))  -- "여러 개의 탭들이 보이시죠?"

    UISignalShow("btnStars")
    Wait(2)
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020011))  -- "요건 [유저의 닉네임] 님께서 스타로 등록한 춤꾼들을 볼 수 있는 {highlight}{bold}스타 목록{/bold}{/highlight} 탭."
    UISignalHide()

    UISignalShow("btnFans")
    Wait(2)
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020012))  -- "요건 [유저의 닉네임] 님을 스타로 등록한 춤꾼들을 볼 수 있는 {highlight}{bold}팬 목록{/bold}{/highlight} 탭."
    UISignalHide()

    UISignalShow("btnBans")
    Wait(2)
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020013))  -- "요건 [유저의 닉네임] 님께서 차단한 춤꾼들을 볼 수 있는 {highlight}{bold}차단 목록{/bold}{/highlight} 탭."
    UISignalHide()
    
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020014))  -- "이 세 가지의 목록을 활용하면 댄스빌 춤꾼들과의 관계를 쉽게 살펴볼 수 있어요."
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020015))  -- "내 스타, 팬에게 놀러가서 아카데미를 어떻게 꾸미고 어떤 뮤직비디오를 만들었는지 구경하는 재미가 쏠쏠하답니다."
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020016))  -- "팬이 새로 만든 뮤직비디오에 댓글이라도 하나 달면 얼마나 사이가 돈독해진다구요!"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020017))  -- "아, 그리고 혹시 특정 춤꾼을 찾아보고 싶으시다면..."

    UISignalShow("btnFindFriends")  --춤꾼 찾기 탭에 빨간 박스
    Wait(2)
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020018))  -- "이 {highlight}{bold}춤꾼 찾기{/bold}{/highlight} 탭에서 춤꾼 이름을 이용해 찾을 수 있어요."
    UISignalHide()
    
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020019))  -- "댄스빌에 와본 적 없는 친구들을 {highlight}{bold}댄스빌{/bold}{/highlight}로 초대할 수도 있어요!"
    
    UISignalShow("btnInviteFriends")  --춤꾼 초대 탭에 빨간 박스
    Wait(2)
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020020))  -- "여기 있는 {highlight}{bold}춤꾼 초대{/bold}{/highlight} 탭을 활용하면 간단해요."
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020021))  -- "친구들이랑 같이 댄스빌을 하면 더 재미지니까 적극 활용해보세요."
    UISignalHide()

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020022))  -- "댄스빌에서는 그 누구도 외로울 필요가 없어요!"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020023))  -- "댄스비전에는 언제나 나를 위로해줄 춤과 음악이 있고,"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820020024))  -- "어딘가에는 분명 나의 춤과 음악을 좋아해 주는 춤꾼도 있을 테니까요!"
    
    -- 독백, 퀘스트 완료
    Wait(1)
    --ScenarioEndingShow() -- "[누군가의 스타, 누군가의 팬] 퀘스트 완료"

    -- 퀘스트 시작/완료/보상
    QuestComplete()
    QuestReward()

    -- 백업했던 배경음 플레이하고 제거
    SoundPlayBGMBase64()
    SoundClearBase64()
    
    -- 동작을 복구
    TownCharacterSetDanceRestore( TownCharacterGetUser())

    --진입 튜토리얼이 끝나면 마을로 돌아가지 않고 해당 UI에 머물러 있는 상태
end


if CheckQuestAppear() then
    -- 마을/댄스비전 진입 시, 유저 캐릭터 바로가기 버튼에 new 표시
    if OnTownRefresh() or OnGameAction("OnAfterSceneEntered/SceneDanceVision") then
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_001_01", "btn_myavt", "btn_myavt/iconNew", 29, 41)
        UIShowWithCCB( "UI_common/ui_icon_new5_main_topbar", "icon_new_ByCCB")
    end
end


if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then
    -- 마을 갱신 시, 유저 캐릭터에 표시
    if OnTownRefresh() then
        TownCharacterAction( TownCharacterGetUser(), "cheer_01")
        TownCharacterSetIconSetTimeStamp( TownCharacterGetUser(), "DANCER_TALK")
        TownCharacterSetDanceIdle( TownCharacterGetUser(), 610002)
    end

    -- 내 춤꾼 팝업 생성 시, 춤꾼들 버튼 해금
    if OnGameAction("OnBeforePopupCreate/PopupTownUser") or OnGameAction("OnBeforeSwapScene/SceneMyInfo") then
        UnlockQuestContents()        
    end
    
    -- 내 춤꾼 팝업 진입 시, 춤꾼들 버튼에 New표시
    if OnGameAction("OnAfterPopupEntered/PopupTownUser") then
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_003_01", "btn_frnd", "btn_frnd/iconNew", 40, 28)
    end
    if OnGameAction("OnAfterSceneEntered/SceneMyInfo") then
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_003_01", "btn_frnd", "btn_frnd/iconNew", 40, 28)        
    end

    -- 춤꾼들 버튼 클릭 시, 유저 캐릭터 바로가기 버튼 new 표시 제거, 춤꾼들 버튼에 New표시 제거
    if OnGameAction("OnUIClick/PopupTownUser/btn_frnd") or OnGameAction("OnUIClick/SceneMyInfo/btn_frnd") then
        UIRemoveNewIconWithCCB("UI_common/ui_btn2_001_01", "btn_myavt", "btn_myavt/iconNew")
        UIRemoveNewIconWithCCB("UI_common/ui_btn2_003_01", "btn_frnd", "btn_frnd/iconNew")
        UIRemoveNewIcon( "btn_frnd", "btn_frnd/iconNew1")
        UIHideWithCCB( "UI_common/ui_icon_new5_main_topbar", "icon_new_ByCCB")
        RefreshNewCount()
    end
    -- 춤꾼들 화면 진입 전, 락 해금
    if OnGameAction("OnBeforeSwapScene/SceneCommunity") then
        UnlockQuestContents()
    end
    -- 춤꾼들 화면 진입 시, 퀘스트 진행 시작
    if OnGameAction("OnAfterSceneEntered/SceneCommunity") then
        ScriptOnQuest()
    end
end





-- PRELOAD_END

if OnQuestReplay() then
 	--TODO
end
