-- 공원(820025) -- 진입형 퀘스트
-- version("0.48.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520307) -- 공원 기능을 열어줌
end


-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO
    return true
end

--유저가 공원 버튼을 누르면 진행(공원 화면으로 전환하지 않고 그 자리에서 진행)
--이 퀘스트를 진행 가능한 상태가 되면, 공원 버튼에 N 표시
--진입 튜토리얼의 경우, 어두운 화면에 퀘스트 제목 뜨는 과정 없음

-- PRELOAD_BEGIN

local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 기존의 배경음 백업
    SoundGetDvmBase64()

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    QuestStart()

    UIHide( "ui_txt_input") -- 공원의 UITextInputOnScene을 임시로 숨기기 위해 UIHide()를 사용합니다.

    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820025001))  -- "앗! 여기에서 또 만나네요!"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820025002))  -- "{highlight}{bold}공원{/bold}{/highlight}이 핫한 건 또 어떻게 아시고!"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820025003))  -- "소통왕으로 거듭난 제가 요즘 제일 자주 찾는 곳이 바로 {highlight}{bold}공원{/bold}{/highlight}이거든요."
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820025004))  -- "공원은 다른 춤꾼들과 {highlight}{bold}함께 음악을 듣고{/bold}{/highlight}, {highlight}{bold}함께 춤추고{/bold}{/highlight}, {highlight}{bold}함께 이야기 나눌 수 있는{/bold}{/highlight} 곳이에요."
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820025005))  -- "그리고 마음에 드는 춤이나 음악이 있으면 즉석에서 바로 {highlight}{bold}배우기{/bold}{/highlight}까지!"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820025006))  -- "여기서 꼭 기억해야할 건, [유저의 닉네임] 님의 춤이나 음악을 누군가에게 가르쳐주면 {highlight}{bold}골드{/bold}{/highlight}를 벌 수 있다는 사실이에요!"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820025007))  -- "배울 때 지불한 비용에서 일부는 춤, 음악을 만든 춤꾼에게 {highlight}{bold}저작권료{/bold}{/highlight}로, 일부는 가르쳐준 춤꾼에게 {highlight}{bold}수강료{/bold}{/highlight}로 전달되니까요!"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820025008))  -- "직접 만드신 춤, 음악을 다른 춤꾼에게 가르쳐주면, {highlight}{bold}저작권료{/bold}{/highlight}와 {highlight}{bold}수강료{/bold}{/highlight}를 모두 [유저의 닉네임] 님께서 가지게 되구요!"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820025009))  -- "즉, [유저의 닉네임] 님께서 만든 춤이나 음악이 널리 퍼져도 부자가 될 수 있고"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820025010))  -- "다른 유저의 춤이나 음악을 많이 배워서 다른 춤꾼들에게 가르쳐줘도 부자가 될 수 있다는 말씀!"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820025011))  -- "공원은 이렇게 소통과 수입을 모두 챙길 수 있는 멋진 곳이죠!"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820025012))  -- "공원에는 {highlight}{bold}여러 종류의 테마{/bold}{/highlight}가 있으니까 되도록 같은 공원에는 들어가지 말자구요."
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(820025013))  -- "[유저의 닉네임] 님 같은 뛰어난 춤꾼이랑 같은 공원에 가면 주목을 받기 힘드니까요! 그럼 저 먼저 갈게요~"

    UIShow( "ui_txt_input") -- 공원의 UITextInputOnScene을 다시 보이기 위해 UIShow()를 사용합니다.

    Wait(0.5)

    QuestComplete()
    QuestReward()
    -- 백업했던 배경음 플레이하고 제거
    SoundPlayBGMBase64()
    SoundClearBase64()

    SendSingularLog(9) -- id 9 : Park_Open

end

if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then
    
        -- 마을 진입 시, 공원 버튼에 new 표시
    if OnTownRefresh() then
        UIUnlockButtonWithCCB("UI_common/ui_btn2_018_02", "btn_park")
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_018_02", "btn_park", "btn_park_town/iconNew", 35, 30)
    end

        -- 댄스비전 진입 시, 공원 버튼에 new 표시
    if OnGameAction("OnAfterSceneEntered/SceneDanceVision") then
        UIUnlockButtonWithCCB("UI_common/ui_btn2_018_01", "btn_park")
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_018_01", "btn_park", "btn_park_dv/iconNew", 35, 30)
    end

        -- 공원 버튼 누르면 모든 공원 버튼의 new표시 제거
    if OnGameAction("OnBlockUIClick/SceneDanceVision/btn_park") or OnGameAction("OnBlockUIClick/SceneTown/btn_park") then
        UIRemoveNewIconWithCCB( "UI_common/ui_btn2_018_02", "btn_park", "btn_park_town/iconNew") -- 댄스비전 버튼
        UIRemoveNewIconWithCCB( "UI_common/ui_btn2_018_01", "btn_park", "btn_park_dv/iconNew") -- 마을 버튼
        ScriptOnQuest()
    end
    
end

-- PRELOAD_END

--퀘스트 다시하기
if OnQuestReplay() then
 	--TODO
end
