-- 차원이 다른 자랑(820043) -- 진입 튜토리얼
-- version("0.51.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520018)  -- 내보내기 기능 열어줌
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
      --TODO
    return true
end

local function RemoveNewicons()
    UIRemoveNewIconWithCCB("UI_common/ui_btn2_001_01", "btn_myavt", "btn_myavt/iconNew")
    UIRemoveNewIcon("btn_info_dance", "btn_info_dance/iconNew")
    UIRemoveNewIcon("btn_info_music", "btn_info_music/iconNew")
    UIRemoveNewIcon("btn_info_mv", "btn_info_mv/iconNew1")

    UIRemoveNewIconWithCCB("UI_common/ui_btn2_003_05", "btn_info_mv", "btn_info_mv/iconNew")

    UIRemoveNewIconWithCCB( "UI_common/ui_btn2_004_02", "btn_share", "btn_share/iconNew")
    UIRemoveNewIconWithCCB( "UI_common/ui_btn2_004_01", "btn_dwld", "btn_dwld/iconNew")

    local ccb_name = GetMvDetailLoadedCCBName()
    UIRemoveNewIconWithCCB( ccb_name, "btn_SNS", "btn_SNS/iconNew")

    UIRemoveNewIconWithCCB( "UI_common/ui_popup_makemv_01", "btn_mv_save", "btn_mv_save/iconNew")
    
    UIHideWithCCB( "UI_common/ui_icon_new5_main_topbar", "icon_new_ByCCB")
    RefreshNewCount()
end

-- PRELOAD_BEGIN
--유저가 [공유] 버튼을 누르면 어떻게 내보내기를 할지 결정하는 팝업이 뜬 상태에서 진행
--이 퀘스트를 진행 가능한 상태가 되면 모든 뮤비, 춤, 음악의 [공유] 버튼에 new 표시(유저 캐릭터 바로가기 버튼, 춤 버튼, 음악 버튼에도 new 표시)

local function ScriptOnQuest()
    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    -- 기존의 배경음 백업
    SoundGetDvmBase64()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    QuestStart()

    -- 스킵 버튼 활성화
    AddQuestSkipButton()
    
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(820043001))  -- "앗! 저...전 수상한 춤요정이 아니에요."
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(820043002))  -- "정말이에요! 전 아무것도 안 했다니까요?"
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(820043003))  -- "아... 역시 [유저의 닉네임] 님의 날카로운 눈은 속일 수가 없군요."
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(820043004))  -- "사실, 제가 만든 {highlight}{bold}공유{/bold}{/highlight} 기능을 시험해보고 있었어요."
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(820043005))  -- "가디 여왕님 몰래 댄스게이트를 이용해서 우주의 틈을 만들어 놨거든요!"
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(820043006))  -- "그래서 댄스빌을 넘어 다른 세계에도 저의 뛰어난 뮤직비디오, 춤, 음악을 자랑할 수 있게 되었죠!"
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(820043007))  -- "우선 이곳에서 뮤직비디오나 춤, 음악을 {highlight}{bold}어떤 형태와 길이{/bold}{/highlight}로 {highlight}{bold}공유{/bold}{/highlight}할지 정한 다음에..."

    -- 음악, 춤은 현재 공유하기 버튼 및 팝업이 추가되지 않은 상태라 예외처리
    if CheckCurrentSceneName("SceneDanceList") then
        if CheckCurrentPopupName("PopupDanceShareLengthSetting") then
            ::jmp_mv_ok::
            RequireButtonWithCCB( "UI_common/ui_popup_dv_mv_export_01", "btn_next")
            if RequireCheckResult("OutOfTouch") then
                DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(820043008))  -- "{highlight}{bold}확인{/bold}{/highlight} 버튼을 누르면 다음 단계로 넘어갈 수 있어요!"
                goto jmp_mv_ok
            end
        end

        Wait(0.5)

        if CheckCurrentPopupName("PopupTermsMVFirstShare") then
            RequireClosePopup("PopupTermsMVFirstShare")
        end  
    elseif CheckCurrentSceneName("SceneMusicList") then
        -- 음악 내보내기는 버튼을 강제로 누르게 할 필요가 없음
    elseif CheckCurrentSceneName("SceneMVDetail") or CheckCurrentSceneName("SceneMVTown") or CheckCurrentSceneName("SceneDanceVisionDetail") then 
        if CheckCurrentPopupName("PopupMusicVideoShareLengthSetting") then
            ::jmp_mv_ok::
            RequireButtonWithCCB( "UI_common/ui_popup_dv_mv_export_01", "btn_ok")
            if RequireCheckResult("OutOfTouch") then
                DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(820043008))  -- "{highlight}{bold}확인{/bold}{/highlight} 버튼을 누르면 다음 단계로 넘어갈 수 있어요!"
                goto jmp_mv_ok
            end
        end

        Wait(0.5)

        if CheckCurrentPopupName("PopupTermsMVFirstShare") then
            RequireClosePopup("PopupTermsMVFirstShare")
        end
    end

    if not CheckCurrentSceneName("SceneMusicList") then
        DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(820043009))  -- "이곳에서 어디로 {highlight}{bold}공유{/bold}{/highlight}할지 선택할 수 있어요!"
        DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(820043010))  -- "유X브, 페이X북, 트위X 등, 다른 세계의 파급력 있는 네트워크를 이용하는 것은 물론이고!"
    end
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(820043011))  -- "뮤직비디오나 춤, 음악을 일단 파일로 저장해두었다가 필요할 때 가져다 쓸 수도 있다구요!"
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(820043012))  -- "5년 동안 불굴의 의지로 정말 힘들게 만든 거니까, 다른 사람들에게는 절대 비밀로 하셔야 돼요! 꼭이요!"
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(820043013))  -- "대신 {highlight}{bold}공유{/bold}{/highlight} 기능을 쓸 수 있게 해드릴게요! 이 정도면 손해보는 장사는 아니죠?"
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(820043014))  -- "그럼 우린 우주 대스타가 되어 다시 만나자구요!"
    
        -- 퀘스트 완료
    Wait(1)

    -- 퀘스트 시작/완료/보상(진입 튜토리얼은 완료, 보상 팝업 안 뜸)

    QuestComplete()
    QuestReward()

    -- 백업했던 배경음 플레이하고 제거
    SoundPlayBGMBase64()
    SoundClearBase64()

    RemoveNewicons()
    --진입 튜토리얼이 끝나면 마을로 돌아가지 않고 해당 UI에 머물러 있는 상태
end



if CheckQuestAppear() then
    -- 마을/댄스비전 진입 시, 유저 캐릭터 바로가기 버튼에 new 표시
    if OnTownRefresh() or OnGameAction("OnAfterSceneEntered/SceneDanceVision") then
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_001_01", "btn_myavt", "btn_myavt/iconNew", 29, 41)
        UIShowWithCCB( "UI_common/ui_icon_new5_main_topbar", "icon_new_ByCCB")
        UnlockQuestContents()
    end
end

if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then
  -- 내 춤꾼 팝업 진입 시 춤 버튼, 음악 버튼에 New표시
  -- 현재는 춤, 음악은 공유하기 버튼이나 팝업이 없으므로 주석
    if OnGameAction("OnAfterPopupEntered/PopupTownUser") then
        UIAddNewIconAt("btn_info_dance", "btn_info_dance/iconNew", 29, 41)
        UIAddNewIconAt("btn_info_music", "btn_info_music/iconNew", 29, 41)
        UIAddNewIconAt("btn_info_mv", "btn_info_mv/iconNew", 29, 41)
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_003_05", "btn_info_mv", "btn_info_mv/iconNew", 29, 41)
    end

    if OnGameAction("OnAfterSceneEntered/SceneMyInfo") then
        UIAddNewIconAt("btn_info_dance", "btn_info_dance/iconNew", 29, 41)
        UIAddNewIconAt("btn_info_music", "btn_info_music/iconNew", 29, 41)
        UIAddNewIconAt("btn_info_mv", "btn_info_mv/iconNew1", 29, 41)
    end

    if OnGameAction("OnAfterPopupEntered/PopupMVChoice") then
        UIAddNewIconAtWithCCB("UI_common/ui_popup_makemv_01", "btn_mv_save", "btn_mv_save/iconNew", 99, 41)
    end


    -- 춤 보관함 화면 진입 시, 공유 버튼에 New표시, 버튼은 임시로 언락처리. UnlockQuestContents()를 사용하면 Scene을 벗어나는 경우 자랑하기 기능 사용이 가능해지므로 버튼만 언락
    if OnGameAction("OnAfterSceneEntered/SceneDanceList") then
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_004_02", "btn_share", "btn_share/iconNew", 35, 30)        
        UIUnlockButtonWithCCB("UI_common/ui_btn2_004_02", "btn_share")
    end

    -- 음악 보관함 화면 진입 시, 공유 버튼에 New표시, 버튼은 임시로 언락처리. UnlockQuestContents()를 사용하면 Scene을 벗어나는 경우 자랑하기 기능 사용이 가능해지므로 버튼만 언락
    if OnGameAction("OnAfterSceneEntered/SceneMusicList") then
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_004_01", "btn_dwld", "btn_dwld/iconNew", 35, 30)        
        UIUnlockButtonWithCCB("UI_common/ui_btn2_004_01", "btn_dwld")
    end

    -- 뮤비 상세보기 화면 진입 시, 공유 버튼에 New표시, 버튼은 임시로 언락처리. UnlockQuestContents()를 사용하면 Scene을 벗어나는 경우 자랑하기 기능 사용이 가능해지므로 버튼만 언락
    if OnGameAction("OnAfterSceneEntered/SceneMVDetail") then
        local ccb_name = GetMvDetailLoadedCCBName()
        UIAddNewIconAtWithCCB( ccb_name, "btn_SNS", "btn_SNS/iconNew", 35, 30)
        UIUnlockButtonWithCCB( ccb_name, "btn_SNS")
    end

    if OnGameAction("OnAfterSceneEntered/SceneDanceVisionDetail") then
        local ccb_name = GetMvDetailLoadedCCBName()
        UIAddNewIconAtWithCCB(ccb_name, "btn_SNS", "btn_SNS/iconNew", 35, 30)
        UIUnlockButtonWithCCB(ccb_name, "btn_SNS")
    end

    -- 공유 조건 팝업 등장 시 퀘스트 진행 시작, 공유 버튼 해금
    -- 춤, 음악에 팝업이 추가되면 아래 팝업 이름 추가 필요
    if OnGameAction("OnAfterPopupEntered/PopupDanceShareLengthSetting") or OnGameAction("OnAfterPopupEntered/PopupMusicSaveSetting") or OnGameAction("OnAfterPopupEntered/PopupMusicVideoShareLengthSetting") then
        if CheckCurrentSceneName("SceneDanceList") or CheckCurrentSceneName("SceneMusicList") or CheckCurrentSceneName("SceneMVDetail") or CheckCurrentSceneName("SceneMVTown") or CheckCurrentSceneName("SceneDanceVisionDetail") then
            UnlockQuestContents()
            ScriptOnQuest()
        end
    end
end


-- PRELOAD_END

if OnQuestReplay() then
  --TODO
end

