npc_id_officer = 110

npc_id_clicked = GetInteger("npc_id_clicked")
user_id_clicked = GetInteger("user_id_clicked")
dancer_seq_clicked = GetInteger("dancer_seq_clicked")

local function Local_SetCharacterWithClothAndHide(npc_id, x, y, clothes_id)
    TownCharacterStandAt(TownCharacterAddNPC(npc_id), x, y)
    if clothes_id ~= 0 then
        TownCharacterWearClothes(TownCharacterGetNPC(npc_id), clothes_id)
    end
    TownCharacterHide(TownCharacterGetNPC(npc_id))
end

local function Local_ShowCharacterAndAction(npc_id, dance_id)
    TownCharacterShow(TownCharacterGetNPC(npc_id))
    TownCharacterActionByID(TownCharacterGetNPC(npc_id), dance_id)
end

if OnTownRefresh() then
    if CheckHasAchievements() and CheckUnlock(520038) then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(npc_id_officer))
        TownCharacterSetAchievement(TownCharacterGetNPC(npc_id_officer))
        TownCharacterSetIcon(TownCharacterGetNPC(npc_id_officer), "Has_Present")
    end
end

if OnTownCharacterClick(TownCharacterGetNPC(npc_id_officer)) then
    if CheckHasAchievements() and CheckUnlock(520038) then
        AddSkipButton("skip_achieve_eff")

        ScriptTownCheckMoveToSide(TownCharacterGetNPC(npc_id_officer), TownCharacterGetUser())

        -- 광장으로 대사
        ScriptTownDialogOpenOnOtherPlace(TownCharacterGetNPC(npc_id_officer))

        -- 요원들을 미리 옷을 입혀 생성한 후 숨겨놓는다.
        Local_SetCharacterWithClothAndHide(110, -2*40, 28*40, 0) -- 요원
        Local_SetCharacterWithClothAndHide(133,  2*40, 28*40, 0) -- 신입요원
        Local_SetCharacterWithClothAndHide(354, -5*40, 29*40, 205704) -- 요원1
        Local_SetCharacterWithClothAndHide(355, -6*40, 27*40, 205703) -- 요원2
        Local_SetCharacterWithClothAndHide(356,  5*40, 29*40, 205008) -- 요원3
        Local_SetCharacterWithClothAndHide(357,  6*40, 27*40, 205702) -- 요원4

        TownCharacterHideNameTag(TownCharacterGetNPC(354))
        TownCharacterHideNameTag(TownCharacterGetNPC(355))
        TownCharacterHideNameTag(TownCharacterGetNPC(356))
        TownCharacterHideNameTag(TownCharacterGetNPC(357))

        -- 광장으로 이동
        SceneTownSetStateEmpty()
        TownCharacterHideAll()
        TownCameraZoomIn(TownCharacterGetNPC(0), 0, 30*40, 1.6)
        Wait(1)

        TownCharacterShow(TownCharacterGetNPC(110))
        TownCharacterStandAt(TownCharacterAddNPC(1), 9*40, 33*40-182)
        TownCharacterRunTo(TownCharacterGetNPC(1), 0*40, 28*40)

        Wait(2.5)
        -- "요원", ""그 동안의 활약에 걸맞은 선물을 준비했습니다."
        DialogOpen(npc_id_officer, STR_NPC(npc_id_officer), "Characters/npc_agent_veteran_001", STR_SCRIPT(300001))

        AnimationAdd("light_2", "Object/obj_license_get_eff_02")
        AnimationAdd("light_1", "Object/obj_license_get_eff_01")
        AnimationSetPos("light_1", 0, 300)
        AnimationSetPos("light_2", 0, 330)
        AnimationRepeat("light_1")
        AnimationRepeat("light_2")

        Wait(0.2)

        TownCharacterActionByID(TownCharacterGetNPC(  1), 612344)
        Local_ShowCharacterAndAction(110, 612345)
        Local_ShowCharacterAndAction(133, 612346)
        Local_ShowCharacterAndAction(354, 612340)
        Local_ShowCharacterAndAction(355, 612341)
        Local_ShowCharacterAndAction(356, 612342)
        Local_ShowCharacterAndAction(357, 612343)
        SoundPlay(47) --=SE=Movie_license
        Wait(0.5) -- 선물 꺼내는 동작까지 대기

        -- 선물 건네주기
        AnimationAdd("give_present", "Object/obj_license_get_01")
        AnimationSetScale("give_present", 1.8)
        AnimationSetPos("give_present", 0, -100)
        AnimationPlay("give_present")

        Wait(3) -- 선물 건네주는 모션 대기

        RemoveSkipButton()

        TownCharacterHide(TownCharacterGetNPC(110))
        TownCharacterHide(TownCharacterGetNPC(133))
        TownCharacterHide(TownCharacterGetNPC(354))
        TownCharacterHide(TownCharacterGetNPC(355))
        TownCharacterHide(TownCharacterGetNPC(356))
        TownCharacterHide(TownCharacterGetNPC(357))

        AnimationRemove("give_present");
        AnimationRemove("light_1");
        AnimationRemove("light_2");

        PushPopupTownAchievement()
    end
end

if OnClickSkipButton("skip_achieve_eff") then

    TownCharacterHide(TownCharacterGetNPC(110))
    TownCharacterHide(TownCharacterGetNPC(133))
    TownCharacterHide(TownCharacterGetNPC(354))
    TownCharacterHide(TownCharacterGetNPC(355))
    TownCharacterHide(TownCharacterGetNPC(356))
    TownCharacterHide(TownCharacterGetNPC(357))

    AnimationRemove("give_present");
    AnimationRemove("light_1");
    AnimationRemove("light_2");

    PushPopupTownAchievement()

end
