arbeit_id = GetInteger("script_arbeit_id")

character_clicked = GetPtr("character_clicked")

arbeit_dancer = GetArbeitDancer(arbeit_id)
arbeit_helper = GetArbeitHelper(arbeit_id)

follower_npc_id = TownCharacterGetNPCID(arbeit_dancer)

-- 카페
-- 카페 주인은 카페 주방 안에 위치
-- 아르바이트를 시작하면 카페 유니폼을 착용하고 카페 안을 돌아다니며 춤을 춤
if arbeit_id == 1000001 then
    local npc_id = 154
    local arbeit_npc = TownCharacterGetNPC(npc_id)

    if arbeit_npc == nil then
        return
    end

    if OnTownRefresh() then
        if CheckArbeitAppeared(arbeit_id) then
            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetIcon(arbeit_npc, "ALBA_COMMON")

        elseif CheckArbeitRunning(arbeit_id) then
            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            TownCharacterSetIcon(arbeit_dancer, "") -- 아르바이트시 이외 아이콘 노출 제거
            TownCharacterDoArbeit(arbeit_id, 1000001, STR_FOLLOWER_DIALOG(follower_npc_id, 710))
            if CheckArbeitHelper(arbeit_id) then
                SceneTownAddArbeitHelper(arbeit_id, -33*40, 43*40)
                --SceneTownAddArbeitHelper(arbeit_id, 25*40, 29*40)   //25-58 =-33,29+14 =43
            end

        elseif CheckArbeitFinished(arbeit_id) then
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            ScriptTownStandAtCafeFront(arbeit_dancer)
            TownCharacterSetIcon(arbeit_dancer, "WORK_COMPLETE")
        end
    end

    if OnArbeitButtonClick() then
        DialogOpen(154, STR_NPC(154) , "Characters/npc_owner_cafe_001", STR_SCRIPT(301001)) -- "누구죠? 저와 함께 일하고 싶은 사람이?"
    end

    if CheckArbeitAppeared(arbeit_id) then
        if OnTownCharacterClick(arbeit_npc) then
            
            ScriptTownMoveToCafe(arbeit_npc, TownCharacterGetUser())
            DialogOpen(154, STR_NPC(154), "Characters/npc_owner_cafe_001", STR_SCRIPT(301002)) -- "커피를 한 잔 하러 오셨나요? 아니면 그냥 절 보러?"
            PushPopupTownNpcWithSelectBox(154)
            TownAutoZoomOut()
        end

    elseif CheckArbeitRunning(arbeit_id) then
        if OnTownCharacterClick(arbeit_npc) then
            
            ScriptTownMoveToCafe(arbeit_npc, TownCharacterGetUser())
            DialogOpen(154, STR_NPC(154), "Characters/npc_owner_cafe_001", STR_SCRIPT(301003)) -- "[arbeit_dancer_name] 문하생이 아주 잘 해주고 있어요."
            GoTown()
        elseif OnTownCharacterClick(arbeit_dancer) then
            
            ScriptTownZoomInCharacterNotHideAll(arbeit_dancer)
            PushPopupTownArbeitStatus(arbeit_id)
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 710) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 710))
            end
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 711) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 711))
            end
        elseif OnTownCharacterClick(arbeit_helper) then
            
            ScriptTownZoomInCharacterNotHideAll(arbeit_helper)
            PushPopupTownArbeitHelpAccept(arbeit_id)
        end

    elseif CheckArbeitFinished(arbeit_id) then
        if OnTownCharacterClick(arbeit_dancer) then
            
            ScriptTownMoveToRightSide(arbeit_dancer)
            TownCharacterSetSpeechBubble(arbeit_dancer, STR_FOLLOWER_DIALOG(follower_npc_id, 1310)) -- "(알바 완료 말풍선)"
            SoundPlayVoice(follower_npc_id, 1310)
            TownCharacterSetExpression(arbeit_dancer, "Smile")
            TownCharacterAction(arbeit_dancer, "cheer_01")
            Wait(2)
            PushPopupTownArbeitComplete(arbeit_id)
            GoTown()
            SoundStopVoice()
        end
    end

    if OnArbeitOpening() then
        
        x_cafe = -41 -- 17 -58 = -41
        y_cafe = 45  -- 31 +14 = 45
        
        WaitCharacterLoad(npc_id)

        -- 카메라 이동후 연출이 끝날때까지 기다림
        TownCameraZoomIn(TownCharacterGetNPC(0), (x_cafe+3)*40, (y_cafe+1)*40, 0.5)
        WaitFinishOpening(10020500) -- 카페 (town_object_id : 10020500)

        -- 카메라 줌인 NPC등장
        TownCameraZoomIn(TownCharacterGetNPC(0), (x_cafe)*40, (y_cafe+1)*40, 2.0)
        Wait(0.5)
        TownCharacterStandAt(TownCharacterAddNPC(npc_id), (x_cafe+12)*40, (y_cafe)*40)
        TownCharacterRunTo(TownCharacterGetNPC(npc_id), (x_cafe)*40, (y_cafe)*40)
        Wait(1)

        -- 대사
        DialogOpen(154, STR_NPC(154), "Characters/npc_owner_cafe_001", STR_SCRIPT(301005)) -- "새로 개업했어요. 춤 추다가 커피 생각나시면 언제든 들러주세요."
        DialogOpen(154, STR_NPC(154), "Characters/npc_owner_cafe_001", STR_SCRIPT(301006)) -- "그나저나... 절 보러오는 여성분들이 많아 일손이 부족하지는 않을까 걱정이네요."

        -- 서버에 저장 다음 오픈 확인
        TownCameraFree()
        WaitProtocolPartTimeOpened(arbeit_id)
        PushPopupConfirm(STR_SCRIPT(301007)) -- "[카페] 오픈!\n문하생이 [카페]에서 아르바이트를 할 수 있어요."

        ShowReviewPopup()
    end

end

-- 광장
-- 광장 관리인은 분수 옆에 위치
-- 옆에 휴대용 오디오와 움직이는 음표들 등장
if arbeit_id ==  1000002 then
    local npc_id = 156
    local arbeit_npc = TownCharacterGetNPC(npc_id)

    if arbeit_npc == nil then
        return
    end

    if OnTownRefresh() then
        if CheckArbeitAppeared(arbeit_id) then
            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetIcon(arbeit_npc, "ALBA_COMMON")

        elseif CheckArbeitRunning(arbeit_id) then
            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            TownCharacterSetIcon(arbeit_dancer, "") -- 아르바이트시 이외 아이콘 노출 제거
            TownCharacterDoArbeit(arbeit_id, 1000002, STR_FOLLOWER_DIALOG(follower_npc_id, 720))
            if CheckArbeitHelper(arbeit_id) then
                SceneTownAddArbeitHelper(arbeit_id, 5*40, 33*40-182)
            end

        elseif CheckArbeitFinished(arbeit_id) then
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            TownCharacterStandAt(arbeit_dancer, 0*40, 37*40)

            TownCharacterSetIcon(arbeit_dancer, "WORK_COMPLETE")
        end
    end

    if OnArbeitButtonClick() then
        DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_SCRIPT(301008)) -- "어떤 분이 광장에서 공연을 하시는지 여쭤봐도... 될까요?"
    end

    if CheckArbeitAppeared(arbeit_id) then
        if OnTownCharacterClick(arbeit_npc) then
            
            ScriptTownMoveToSide(arbeit_npc)
            DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_SCRIPT(301009)) -- "아... 제가 도와드려야 되는데... 도와드릴 수 있을지..."
            PushPopupTownNpcWithSelectBox(156)
            TownAutoZoomOut()            
        end

    elseif CheckArbeitRunning(arbeit_id) then
        if OnTownCharacterClick(arbeit_npc) then
            
            ScriptTownMoveToSide(arbeit_npc)
            DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_SCRIPT(301010)) -- "[arbeit_dancer_name] 님 덕분에 광장 분위기가 밝아졌어요!"
            GoTown()
        elseif OnTownCharacterClick(arbeit_dancer) then
            
            ScriptTownZoomInCharacterNotHideAll(arbeit_dancer)
            PushPopupTownArbeitStatus(arbeit_id)

            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 720) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 720))
            end
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 721) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 721))
            end
        elseif OnTownCharacterClick(arbeit_helper) then
            
            ScriptTownZoomInCharacterNotHideAll(arbeit_helper)
            PushPopupTownArbeitHelpAccept(arbeit_id)
        end

    elseif CheckArbeitFinished(arbeit_id) then
        if OnTownCharacterClick(arbeit_dancer) then
            ScriptTownMoveToRightSide(arbeit_dancer)
            TownCharacterSetSpeechBubble(arbeit_dancer, STR_FOLLOWER_DIALOG(follower_npc_id, 1310)) -- "(알바 완료 말풍선)"
            SoundPlayVoice(follower_npc_id, 1310)
            TownCharacterSetExpression(arbeit_dancer, "Smile")
            TownCharacterAction(arbeit_dancer, "cheer_01")
            Wait(2)
            PushPopupTownArbeitComplete(arbeit_id)
            GoTown()
            SoundStopVoice()
        end
    end

    if OnArbeitOpening() then

        WaitCharacterLoad(npc_id)

        -- 카메라 줌인 NPC등장
        TownCameraZoomIn(TownCharacterGetNPC(0), 5*40, 34*40, 2.0)
        Wait(0.5)
        TownCharacterStandAt(TownCharacterAddNPC(npc_id), -5*40, 38*40)
        TownCharacterRunTo(TownCharacterGetNPC(npc_id), 5*40, 33*40)
        Wait(1)

        -- 대사
        DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_SCRIPT(301012)) -- "음.. 제가 광장 관리를 새로 맡게 된 요원이 맞긴 한데..."
        DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_SCRIPT(301013)) -- "제가 잘 할 수... 있을까요?"

        -- 서버에 저장 다음 오픈 확인
        TownCameraFree()
        WaitProtocolPartTimeOpened(arbeit_id)

        PushPopupConfirm(STR_SCRIPT(301014)) -- "[광장] 오픈!\n문하생이 [광장]에서 아르바이트를 할 수 있어요."

        ShowReviewPopup()
    end

end

-- 레스토랑
-- 레스토랑 주인은 레스토랑 주방 혹은 계산대에 위치
-- 레스토랑 유니폼을 착용
if arbeit_id == 1000003 then
    local npc_id = 155
    local arbeit_npc = TownCharacterGetNPC(npc_id)

    if arbeit_npc == nil then
        return
    end

    if OnTownRefresh() then
        if CheckArbeitAppeared(arbeit_id) then
            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetIcon(arbeit_npc, "ALBA_COMMON")

        elseif CheckArbeitRunning(arbeit_id) then
            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            TownCharacterSetIcon(arbeit_dancer, "") -- 아르바이트시 이외 아이콘 노출 제거
            TownCharacterDoArbeit(arbeit_id, 1000003, STR_FOLLOWER_DIALOG(follower_npc_id, 730))
            if CheckArbeitHelper(arbeit_id) then
                SceneTownAddArbeitHelper(arbeit_id, -20*40, 44*40)
            end

        elseif CheckArbeitFinished(arbeit_id) then
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            ScriptTownStandAtRestaurantFront(arbeit_dancer)
            TownCharacterSetIcon(arbeit_dancer, "WORK_COMPLETE")
        end

    end

    if OnArbeitButtonClick() then
        -- "레스토랑 주인", "우리 레스토랑의 새로운 가족이 될 춤꾼이 누구지?"
        DialogOpen(155, STR_NPC(155), "Characters/npc_owner_restaurant_001", STR_SCRIPT(301015))
    end

    if CheckArbeitAppeared(arbeit_id) then
        if OnTownCharacterClick(arbeit_npc) then
            
            ScriptTownMoveToRestaurant(arbeit_npc, TownCharacterGetUser())
            -- "레스토랑 주인", "우리 레스토랑의 맛을 잊지 못하고 또 왔군!"
            DialogOpen(155, STR_NPC(155), "Characters/npc_owner_restaurant_001", STR_SCRIPT(301016))
            PushPopupTownNpcWithSelectBox(155)
            TownAutoZoomOut()            
        end

    elseif CheckArbeitRunning(arbeit_id) then
        if OnTownCharacterClick(arbeit_npc) then
            
            ScriptTownMoveToRestaurant(arbeit_npc, TownCharacterGetUser())
            -- "레스토랑 주인", "[arbeit_dancer_name] 녀석, 손이 야무진 게 아주 마음에 들어!"
            DialogOpen(155, STR_NPC(155), "Characters/npc_owner_restaurant_001", STR_SCRIPT(301017))
            GoTown()
        elseif OnTownCharacterClick(arbeit_dancer) then
            
            ScriptTownZoomInCharacterNotHideAll(arbeit_dancer)
            PushPopupTownArbeitStatus(arbeit_id)

            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 730) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 730))
            end
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 731) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 731))
            end
        elseif OnTownCharacterClick(arbeit_helper) then
            
            ScriptTownZoomInCharacterNotHideAll(arbeit_helper)
            PushPopupTownArbeitHelpAccept(arbeit_id)
        end

    elseif CheckArbeitFinished(arbeit_id) then
        if OnTownCharacterClick(arbeit_dancer) then
            
            ScriptTownMoveToRightSide(arbeit_dancer)
            TownCharacterSetSpeechBubble(arbeit_dancer, STR_FOLLOWER_DIALOG(follower_npc_id, 1310)) -- "(알바 완료 말풍선)"
            SoundPlayVoice(follower_npc_id, 1310)
            TownCharacterSetExpression(arbeit_dancer, "Smile")
            TownCharacterAction(arbeit_dancer, "cheer_01")
            Wait(2)
            PushPopupTownArbeitComplete(arbeit_id)
            GoTown()
            SoundStopVoice()
        end
    end

    -- 아르바이트가 처음 열렸을때
    if OnArbeitOpening() then

        WaitCharacterLoad(npc_id)

        -- 카메라 이동후 연출이 끝날때까지 기다림
        TownCameraZoomIn(TownCharacterGetNPC(0), -21*40, 46*40, 0.5)
        WaitFinishOpening(10020600) -- 레스토랑 (town_object_id : 10020600)

        -- 카메라 줌인 NPC등장
        TownCameraZoomIn(TownCharacterGetNPC(0), -20*40, 48*40, 2.0)
        Wait(0.5)
        TownCharacterStandAt(TownCharacterAddNPC(npc_id), -30*40, 43*40)
        TownCharacterRunTo(TownCharacterGetNPC(npc_id), -20*40, 46*40)
        Wait(1)

        -- 대사 [레스토랑 주인]
        -- "어디에서도 맛 볼 수 없었던 최고의 한끼를 보장하지! 껄껄껄!"
        -- "우리 레스토랑이 유명세를 타기 전에 함께 가족처럼 일 할 믿음직한 사람을 좀 찾아봐야겠군!"
        DialogOpen(155, STR_NPC(155), "Characters/npc_owner_restaurant_001", STR_SCRIPT(301019))
        DialogOpen(155, STR_NPC(155), "Characters/npc_owner_restaurant_001", STR_SCRIPT(301020))

        -- 서버에 저장 다음 오픈 확인
        TownCameraFree()
        WaitProtocolPartTimeOpened(arbeit_id)
        PushPopupConfirm(STR_SCRIPT(301021)) -- "[레스토랑] 오픈!\n문하생이 [레스토랑]에서 아르바이트를 할 수 있어요."

        ShowReviewPopup()
    end
end

-- 클럽
-- 클럽 DJ는 클럽 DJ박스에 위치
-- 문하생을 집중적으로 비추는 조명 연출 가미
if arbeit_id == 1000004 then
    local npc_id = 148
    local arbeit_npc = TownCharacterGetNPC(npc_id)

    if arbeit_npc == nil then
        return
    end

    if OnTownRefresh() then
        if CheckArbeitAppeared(arbeit_id) then
            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetIcon(arbeit_npc, "ALBA_COMMON")

        elseif CheckArbeitRunning(arbeit_id) then
            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            TownCharacterSetIcon(arbeit_dancer, "") -- 아르바이트시 이외 아이콘 노출 제거
            TownCharacterDoArbeit(arbeit_id, 1000004, STR_FOLLOWER_DIALOG(follower_npc_id, 740))
            if CheckArbeitHelper(arbeit_id) then
                SceneTownAddArbeitHelper(arbeit_id, 32*40, 16*40)
            end

        elseif CheckArbeitFinished(arbeit_id) then
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            ScriptTownStandAtClubFront(arbeit_dancer)
            TownCharacterSetIcon(arbeit_dancer, "WORK_COMPLETE")
        end
    end

    if OnArbeitButtonClick() then
        -- "클럽 DJ"
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_SCRIPT(301022)) -- "여기에서 공연할 용자는 누구?"
    end

    if CheckArbeitAppeared(arbeit_id) then
        if OnTownCharacterClick(arbeit_npc) then
            
            ScriptTownMoveToClub(arbeit_npc, TownCharacterGetUser())
            SoundPlayWithLock(30) --=BGM=Character_DJ
            -- "이곳은 진정한 춤꾼들의 성지! 춤으로 음악과 대화하는 긍지!"
            DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_SCRIPT(301023))
            PushPopupTownNpcWithSelectBox(148)
            TownAutoZoomOut()            
        end

    elseif CheckArbeitRunning(arbeit_id) then
        if OnTownCharacterClick(arbeit_npc) then
            
            ScriptTownMoveToClub(arbeit_npc, TownCharacterGetUser())
            SoundPlayWithLock(30) --=BGM=Character_DJ
            PushPopupTownClub(0)
            -- "[arbeit_dancer_name]의 공연 덕에 살아나는 분위기! 다른 클럽들은 대위기!"
            DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_SCRIPT(301024))
        elseif OnTownCharacterClick(arbeit_dancer) then
            
            ScriptTownZoomInCharacterNotHideAll(arbeit_dancer)
            PushPopupTownArbeitStatus(arbeit_id)

            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 740) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 740))
            end
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 741) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 741))
            end
        elseif OnTownCharacterClick(arbeit_helper) then
            
            ScriptTownZoomInCharacterNotHideAll(arbeit_helper)
            PushPopupTownArbeitHelpAccept(arbeit_id)
        end

    elseif CheckArbeitFinished(arbeit_id) then
        if OnTownCharacterClick(arbeit_dancer) then
            
            ScriptTownMoveToRightSide(arbeit_dancer)
            TownCharacterSetSpeechBubble(arbeit_dancer, STR_FOLLOWER_DIALOG(follower_npc_id, 1310)) -- "(알바 완료 말풍선)"
            SoundPlayVoice(follower_npc_id, 1310)
            TownCharacterSetExpression(arbeit_dancer, "Smile")
            TownCharacterAction(arbeit_dancer, "cheer_01")
            Wait(2)
            PushPopupTownArbeitComplete(arbeit_id)
            GoTown()
            SoundStopVoice()
        end
    end

    if OnArbeitOpening() then
        
        -- 카메라 이동후 연출이 끝날때까지 기다림
        TownCameraZoomIn(TownCharacterGetNPC(0), 32*40, 21*40, 2.0)
        Wait(0.5) -- 오픈되는 건물이 없음

        -- 대사
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_SCRIPT(301026)) -- "나는 걸었지. 고독한 예술의 루트."
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_SCRIPT(301027)) -- "사람들은 걸렀지. 지독한 아집의 비트."
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_SCRIPT(301028)) -- "이제는 받을래. 대중들의 찬사."
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_SCRIPT(301029)) -- "그래서 필요해. 날 도와줄 천사."

        -- 서버에 저장 다음 오픈 확인
        TownCameraFree()
        WaitProtocolPartTimeOpened(arbeit_id)
        PushPopupConfirm(STR_SCRIPT(301030)) -- "[클럽] 오픈!\n문하생이 [클럽]에서 아르바이트를 할 수 있어요."

        ShowReviewPopup()
    end

end

-- 1000005	홍보 - 옷 가게
-- 1000006	홍보 - 미용실
-- 1000007	홍보 – 인테리어
-- 홍보 >> 이거 알바 3개로나누어도?
-- 옷 가게 / 미용실 / 인테리어 가게 중, 임의의 한 시설에 해당 시설의 담당 NPC 머리 위에 알바 가능 표시(!?)
-- 원래 옷 가게 / 미용실 / 인테리어 가게 NPC가 줌인 될 때 등장하는 기존의 버튼과 [아르바이트] 버튼이 함께 등장
-- 해당 시설의 홍보용 의상을 착용
-- 해당 시설 홍보용 입간판이 옆에 등장
if arbeit_id == 1000005 then
    local npc_id = 146
    local arbeit_npc = TownCharacterGetNPC(npc_id)

    if arbeit_npc == nil then
        return
    end

    if OnTownRefresh() then
        -- 알바 전용 아이템 감춤
        SceneTownHideItem(10020215)
        SceneTownHideItem(10020216)
        SceneTownHideItem(10020217)
        SceneTownHideItem(10020218)
        SceneTownHideItem(10020219)
        SceneTownHideItem(10020220)

        if CheckArbeitAppeared(arbeit_id) then
            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetIcon(arbeit_npc, "ALBA_COMMON")

        elseif CheckArbeitRunning(arbeit_id) then
            -- 알바 전용 아이템 보이기
            SceneTownShowItem(10020215)
            SceneTownShowItem(10020216)
            SceneTownShowItem(10020217)
            SceneTownShowItem(10020218)
            SceneTownShowItem(10020219)
            SceneTownShowItem(10020220)

            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            TownCharacterSetIcon(arbeit_dancer, "") -- 아르바이트시 이외 아이콘 노출 제거
            TownCharacterDoArbeit(arbeit_id, 1000005, STR_FOLLOWER_DIALOG(follower_npc_id, 750))
            if CheckArbeitHelper(arbeit_id) then
                SceneTownAddArbeitHelper(arbeit_id, -16*40, 7*40)
            end

        elseif CheckArbeitFinished(arbeit_id) then
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            ScriptTownStandAtDressFront(arbeit_dancer)
            TownCharacterSetIcon(arbeit_dancer, "WORK_COMPLETE")
        end
    end

    if OnArbeitButtonClick() then
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_SCRIPT(301031)) -- "우리 가게를 멋지게 알려줄 춤꾼이 누구죠?"
    end

    if CheckArbeitAppeared(arbeit_id) then
        if OnTownCharacterClick(arbeit_npc) then
            
            ScriptTownMoveToDress(arbeit_npc, TownCharacterGetUser())
            SoundPlayWithLock(68) --=BGM=Theme_Clothshop
            PushPopupTownNpcWithSelectBox(146)
        end

    elseif CheckArbeitRunning(arbeit_id) then
        if OnTownCharacterClick(arbeit_npc) then
            
            ScriptTownMoveToDress(arbeit_npc, TownCharacterGetUser())
            SoundPlayWithLock(68) --=BGM=Theme_Clothshop
            PushPopupTownDress(0)
            DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_SCRIPT(301032)) -- "덕분에 오늘 장사는 아주 만족스럽군요~"
        elseif OnTownCharacterClick(arbeit_dancer) then
            
            ScriptTownZoomInCharacterNotHideAll(arbeit_dancer)
            PushPopupTownArbeitStatus(arbeit_id)
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 750) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 750))
            end
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 751) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 751))
            end
        elseif OnTownCharacterClick(arbeit_helper) then
            
            ScriptTownZoomInCharacterNotHideAll(arbeit_helper)
            PushPopupTownArbeitHelpAccept(arbeit_id)
        end

    elseif CheckArbeitFinished(arbeit_id) then
        if OnTownCharacterClick(arbeit_dancer) then
            
            ScriptTownMoveToRightSide(arbeit_dancer)
            TownCharacterSetSpeechBubble(arbeit_dancer, STR_FOLLOWER_DIALOG(follower_npc_id, 1310)) -- "(알바 완료 말풍선)"
            SoundPlayVoice(follower_npc_id, 1310)
            TownCharacterSetExpression(arbeit_dancer, "Smile")
            TownCharacterAction(arbeit_dancer, "cheer_01")
            Wait(2)
            PushPopupTownArbeitComplete(arbeit_id)
            GoTown()
            SoundStopVoice()
        end
    end

    if OnArbeitOpening() then

        -- 카메라 이동후 연출이 끝날때까지 기다림
        TownCameraZoomIn(TownCharacterGetNPC(0), -15*40, 16*40, 2.0)
        Wait(0.5) -- 오픈되는 건물이 없음

        -- 대사
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_SCRIPT(301034)) -- "요즘 이 일대 상점가들이 다들 장사가 안 돼서 난리에요."
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_SCRIPT(301035)) -- "대대적으로 홍보라도 하든지 해야지, 원."

        -- 서버에 저장 다음 오픈 확인
        TownCameraFree()
        WaitProtocolPartTimeOpened(arbeit_id)
        PushPopupConfirm(STR_SCRIPT(301036)) -- "[옷 가게] 오픈!\n문하생이 [옷 가게]에서 아르바이트를 할 수 있어요."

        ShowReviewPopup()
    end

end

if arbeit_id == 1000006 then
    local npc_id = 145
    local arbeit_npc = TownCharacterGetNPC(npc_id)

    if arbeit_npc == nil then
        return
    end

    if OnTownRefresh() then
        -- 알바 전용 아이템 감춤
        SceneTownHideItem(10020418)
        SceneTownHideItem(10020419)
        SceneTownHideItem(10020420)

        if CheckArbeitAppeared(arbeit_id) then
            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetIcon(arbeit_npc, "ALBA_COMMON")

        elseif CheckArbeitRunning(arbeit_id) then
            -- 알바 전용 아이템 보이기
            SceneTownShowItem(10020418)
            SceneTownShowItem(10020419)
            SceneTownShowItem(10020420)

            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            TownCharacterSetIcon(arbeit_dancer, "") -- 아르바이트시 이외 아이콘 노출 제거
            TownCharacterDoArbeit(arbeit_id, 1000006, STR_FOLLOWER_DIALOG(follower_npc_id, 760))
            if CheckArbeitHelper(arbeit_id) then
                SceneTownAddArbeitHelper(arbeit_id, 15*40, 7*40)
            end

        elseif CheckArbeitFinished(arbeit_id) then
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            ScriptTownStandAtBeautyFront(arbeit_dancer)
            TownCharacterSetIcon(arbeit_dancer, "WORK_COMPLETE")
        end
    end

    if OnArbeitButtonClick() then
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_SCRIPT(301037)) -- "우리 샵에 손님을 더 늘려준다는 거지? 누가?"
    end

    if CheckArbeitAppeared(arbeit_id) then
        if OnTownCharacterClick(arbeit_npc) then
            
            ScriptTownMoveToBeauty(arbeit_npc, TownCharacterGetUser())
            SoundPlayWithLock(72) --=BGM=Theme_Hairshop
            DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_SCRIPT(301038)) -- "오호호~ 새로운 스타일을 받아들일 마음의 준비는 되었겠지~?"
            PushPopupTownNpcWithSelectBox(145)
            TownAutoZoomOut()            
        end

    elseif CheckArbeitRunning(arbeit_id) then
        if OnTownCharacterClick(arbeit_npc) then
            
            ScriptTownMoveToBeauty(arbeit_npc, TownCharacterGetUser())
            SoundPlayWithLock(72) --=BGM=Theme_Hairshop
            DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_SCRIPT(301039)) -- "손님이 많은 건 좋은데, 머리에 예술혼을 불어넣을 여유가 없지 뭐야~"
            PushPopupTownBeauty(0)
        elseif OnTownCharacterClick(arbeit_dancer) then
            
            ScriptTownZoomInCharacterNotHideAll(arbeit_dancer)
            PushPopupTownArbeitStatus(arbeit_id)
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 760) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 760))
            end
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 761) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 761))
            end
        elseif OnTownCharacterClick(arbeit_helper) then
            
            ScriptTownZoomInCharacterNotHideAll(arbeit_helper)
            PushPopupTownArbeitHelpAccept(arbeit_id)
        end

    elseif CheckArbeitFinished(arbeit_id) then
        if OnTownCharacterClick(arbeit_dancer) then
            
            ScriptTownMoveToRightSide(arbeit_dancer)
            TownCharacterSetSpeechBubble(arbeit_dancer, STR_FOLLOWER_DIALOG(follower_npc_id, 1310)) -- "(알바 완료 말풍선)"
            SoundPlayVoice(follower_npc_id, 1310)
            TownCharacterSetExpression(arbeit_dancer, "Smile")
            TownCharacterAction(arbeit_dancer, "cheer_01")
            Wait(2)
            PushPopupTownArbeitComplete(arbeit_id)
            GoTown()
            SoundStopVoice()
        end
    end

    if OnArbeitOpening() then

        -- 옷가게랑 동시에 열림으로 오픈연출 없음
        WaitProtocolPartTimeOpened(arbeit_id)

    end

end

if arbeit_id == 1000007 then
    local npc_id = 144
    local arbeit_npc = TownCharacterGetNPC(npc_id)

    if arbeit_npc == nil then
        return
    end

    if OnTownRefresh() then
        -- 알바 전용 아이템 감춤
        SceneTownHideItem(10020312)
        SceneTownHideItem(10020313)
        SceneTownHideItem(10020314)
        SceneTownHideItem(10020315)
        SceneTownHideItem(10020316)
        SceneTownHideItem(10020317)

        if CheckArbeitAppeared(arbeit_id) then
            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetIcon(arbeit_npc, "ALBA_COMMON")

        elseif CheckArbeitRunning(arbeit_id) then
            -- 알바 전용 아이템 보이기
            SceneTownShowItem(10020312)
            SceneTownShowItem(10020313)
            SceneTownShowItem(10020314)
            SceneTownShowItem(10020315)
            SceneTownShowItem(10020316)
            SceneTownShowItem(10020317)

            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            TownCharacterSetIcon(arbeit_dancer, "") -- 아르바이트시 이외 아이콘 노출 제거
            TownCharacterDoArbeit(arbeit_id, 1000007, STR_FOLLOWER_DIALOG(follower_npc_id, 770))
            if CheckArbeitHelper(arbeit_id) then
                SceneTownAddArbeitHelper(arbeit_id, -36*40, 7*40)
            end

        elseif CheckArbeitFinished(arbeit_id) then
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            ScriptTownStandAtInteriorFront(arbeit_dancer)
            TownCharacterSetIcon(arbeit_dancer, "WORK_COMPLETE")
        end
    end

    if OnArbeitButtonClick() then
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_SCRIPT(301041)) -- "누가 홍보를 도와주는 거야? 누구든 내가 잘 해줄게~"
    end

    if CheckArbeitAppeared(arbeit_id) then
        if OnTownCharacterClick(arbeit_npc) then
            
            ScriptTownMoveToInterior(arbeit_npc, TownCharacterGetUser())
            SoundPlayWithLock(67) --=BGM=Theme_Interiorshop
            DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_SCRIPT(301042)) -- "아카데미를 멋지게 꾸며줄까? 아니면 더 넓게?"
            PushPopupTownNpcWithSelectBox(144)            
            TownAutoZoomOut()        
        end

    elseif CheckArbeitRunning(arbeit_id) then
        if OnTownCharacterClick(arbeit_npc) then
            
            ScriptTownMoveToInterior(arbeit_npc, TownCharacterGetUser())
            SoundPlayWithLock(67) --=BGM=Theme_Interiorshop
            PushPopupTownInterior(0)
            DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_SCRIPT(301043)) -- "오늘 받은 주문이 몇 건인지 세지도 못 하겠어! 고마워~"
            TownAutoZoomOut()
        elseif OnTownCharacterClick(arbeit_dancer) then
            
            ScriptTownZoomInCharacterNotHideAll(arbeit_dancer)
            PushPopupTownArbeitStatus(arbeit_id)
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 770) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 770))
            end
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 771) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 771))
            end
        elseif OnTownCharacterClick(arbeit_helper) then
            
            ScriptTownZoomInCharacterNotHideAll(arbeit_helper)
            PushPopupTownArbeitHelpAccept(arbeit_id)
        end

    elseif CheckArbeitFinished(arbeit_id) then
        if OnTownCharacterClick(arbeit_dancer) then
            
            ScriptTownMoveToRightSide(arbeit_dancer)
            TownCharacterSetSpeechBubble(arbeit_dancer, STR_FOLLOWER_DIALOG(follower_npc_id, 1310)) -- "(알바 완료 말풍선)"
            SoundPlayVoice(follower_npc_id, 1310)
            TownCharacterSetExpression(arbeit_dancer, "Smile")
            TownCharacterAction(arbeit_dancer, "cheer_01")
            Wait(2)
            PushPopupTownArbeitComplete(arbeit_id)
            GoTown()
            SoundStopVoice()
        end
    end

    if OnArbeitOpening() then

        -- 옷가게랑 동시에 열림으로 오픈연출 없음
        WaitProtocolPartTimeOpened(arbeit_id)

    end

end

-- 야외 무대
-- 야외 무대 관리인은 무대 옆에 위치
-- 문하생을 집중적으로 비추는 조명 연출, 무대 스피커 주위에 움직이는 음표 연출 가미
-- 알바를 완료한 문하생을 터치하면 줌인, 좋아하는 표정과 몸짓(좋아요를 받았을 때와 동일)을 하고, 아래의 팝업창 등장
if arbeit_id == 1000008 then
    local npc_id = 157
    local arbeit_npc = TownCharacterGetNPC(npc_id)

    if arbeit_npc == nil then
        return
    end

    if OnTownRefresh() then
        -- 알바 전용 아이템 감춤
        SceneTownHideItem(10020814)
        SceneTownHideItem(10020816)
        SceneTownHideItem(10020803)
        SceneTownHideItem(10020804)
        SceneTownHideItem(10020806)
        SceneTownHideItem(10020809)
        SceneTownHideItem(10020810)
        SceneTownHideItem(10020812)

        if CheckArbeitAppeared(arbeit_id) then
            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetIcon(arbeit_npc, "ALBA_COMMON")

        elseif CheckArbeitRunning(arbeit_id) then
            SceneTownShowItem(10020814)
            SceneTownShowItem(10020816)
            SceneTownShowItem(10020803)
            SceneTownShowItem(10020804)
            SceneTownShowItem(10020806)
            SceneTownShowItem(10020809)
            SceneTownShowItem(10020810)
            SceneTownShowItem(10020812)

            SceneTownHideItem(10020813)
            SceneTownHideItem(10020815)
            SceneTownHideItem(10020801)
            SceneTownHideItem(10020802)
            SceneTownHideItem(10020805)
            SceneTownHideItem(10020807)
            SceneTownHideItem(10020808)
            SceneTownHideItem(10020811)

            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            TownCharacterSetIcon(arbeit_dancer, "") -- 아르바이트시 이외 아이콘 노출 제거
            TownCharacterDoArbeit(arbeit_id, 1000008, STR_FOLLOWER_DIALOG(follower_npc_id, 780))
            if CheckArbeitHelper(arbeit_id) then
                SceneTownAddArbeitHelper(arbeit_id, -5*40, 33*40-182)
            end

        elseif CheckArbeitFinished(arbeit_id) then
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            ScriptTownStandAtOutStageFront(arbeit_dancer)
            TownCharacterSetIcon(arbeit_dancer, "WORK_COMPLETE")
        end
    end

    if OnArbeitButtonClick() then
        DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_SCRIPT(301045)) -- "꿈과 희망을 전파할 우리 일에 동참하실 분이 누구죠?"
    end

    if CheckArbeitAppeared(arbeit_id) then
        if OnTownCharacterClick(arbeit_npc) then
            
            ScriptTownMoveToSide(arbeit_npc)
            DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_SCRIPT(301046)) -- "내가 준비한 무대에서 춤꾼들이 공연을 하는 게 얼마나 뿌듯한 일인지 모를 겁니다."
            PushPopupTownNpcWithSelectBox(157)            
            TownAutoZoomOut()            
        end

    elseif CheckArbeitRunning(arbeit_id) then
        if OnTownCharacterClick(arbeit_npc) then
            
            ScriptTownMoveToSide(arbeit_npc)
            DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_SCRIPT(301047)) -- "역시 [유저의 닉네임] 님의 아카데미 출신은 공연의 질이 다르군요!"
            GoTown()
        elseif OnTownCharacterClick(arbeit_dancer) then
            
            ScriptTownZoomInCharacterNotHideAll(arbeit_dancer)
            PushPopupTownArbeitStatus(arbeit_id)
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 780) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 780))
            end
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 781) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 781))
            end
        elseif OnTownCharacterClick(arbeit_helper) then
            
            ScriptTownZoomInCharacterNotHideAll(arbeit_helper)
            PushPopupTownArbeitHelpAccept(arbeit_id)
        end

    elseif CheckArbeitFinished(arbeit_id) then
        if OnTownCharacterClick(arbeit_dancer) then
            
            SceneTownHideItem(10020814)
            SceneTownHideItem(10020816)
            SceneTownHideItem(10020803)
            SceneTownHideItem(10020804)
            SceneTownHideItem(10020806)
            SceneTownHideItem(10020809)
            SceneTownHideItem(10020810)
            SceneTownHideItem(10020812)

            SceneTownShowItem(10020813)
            SceneTownShowItem(10020815)
            SceneTownShowItem(10020801)
            SceneTownShowItem(10020802)
            SceneTownShowItem(10020805)
            SceneTownShowItem(10020807)
            SceneTownShowItem(10020808)
            SceneTownShowItem(10020811)

            ScriptTownMoveToRightSide(arbeit_dancer)
            TownCharacterSetSpeechBubble(arbeit_dancer, STR_FOLLOWER_DIALOG(follower_npc_id, 1310)) -- "(알바 완료 말풍선)"
            SoundPlayVoice(follower_npc_id, 1310)
            TownCharacterSetExpression(arbeit_dancer, "Smile")
            TownCharacterAction(arbeit_dancer, "cheer_01")
            Wait(2)
            PushPopupTownArbeitComplete(arbeit_id)
            GoTown()
            SoundStopVoice()
        end
    end

    if OnArbeitOpening() then
        
        x_stage = 27 -- 20
        y_stage = 42 -- 41
        
        WaitCharacterLoad(npc_id)

        -- 카메라 이동후 연출이 끝날때까지 기다림
        TownCameraZoomIn(TownCharacterGetNPC(0), (x_stage)*40, (y_stage+5)*40, 0.5)
        WaitFinishOpening(10020800) -- 야외 무대 (town_object_id : 10020800)

        -- 카메라 줌인 NPC등장
        TownCameraZoomIn(TownCharacterGetNPC(0), (x_stage+1)*40, (y_stage+1)*40, 2.0)
        Wait(0.5)
        TownCharacterStandAt(TownCharacterAddNPC(npc_id), (x_stage+11)*40, (y_stage)*40)
        TownCharacterRunTo(TownCharacterGetNPC(npc_id), (x_stage+1)*40, (y_stage)*40)
        Wait(1)

        -- 대사
        DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_SCRIPT(301049)) -- "앞으로 이 무대는 많은 춤꾼들이 꿈을 키우는 장소가 될 겁니다!"
        DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_SCRIPT(301050)) -- "[유저의 닉네임] 님의 아카데미에서도 많이 도와주시리라 믿어 의심치 않습니다!"

        -- 서버에 저장 다음 오픈 확인
        TownCameraFree()
        WaitProtocolPartTimeOpened(arbeit_id)
        PushPopupConfirm(STR_SCRIPT(301051)) -- "[야외 무대] 오픈!\n문하생이 [야외 무대]에서 아르바이트를 할 수 있어요."

        ShowReviewPopup()
    end

end
