
local function ScriptNPCCommonDialog(npc_id)
    local text_off = GetRandMinMax(201, 203)

    if CheckUnlockWithNpcID(npc_id) then
        text_off = 701
    end

    DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_NPC_DIALOG(npc_id, text_off))

end

local function ScriptNPCCommunicateDialog(npc_id)

    local closeness = GetNPCCloseness(npc_id)

    if closeness < 20 then
        DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_NPC_DIALOG(npc_id, 304))

    elseif closeness < 50 then
        DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_NPC_DIALOG(npc_id, 303))

    elseif closeness < 80 then
        DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_NPC_DIALOG(npc_id, 302))

    else
        DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_NPC_DIALOG(npc_id, 301))

    end

end

local function ScriptNPCClosenessEvent(npc_id)

    DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_NPC_DIALOG(npc_id, 403))

    DescriptionBarShow(STR_SCRIPT(304001)) -- "당신 뮤비에 나오는 춤을 추고 있어요~!!"

    -- NPC가 뮤비 춤 추기
    -- 춤이 군무일 경우, 군무에 사용한 여러 춤 중 하나만 춤
    TownNPCDanceMVOnAir(npc_id)
    Wait(5)

    DescriptionBarHide()

end

if OnTownAnyCharacterClick() then
    local npc_id = GetInteger("npc_id_clicked")
    local communicate_npc_id = GetInteger("communicate_npc_id")

    if CheckNPCRoamingInTown(npc_id) then

        if npc_id == communicate_npc_id and CheckUnlock(520016) then
            ScriptTownMoveToSide(TownCharacterGetNPC(npc_id))

            SendProtocolCommunicateNPC(npc_id)

            -- 대화 대상 NPC와의 호감도가 일정 이상인 경우 일정 확률로 뮤비 춤 따라하기(분기처리)
            if CheckNPCClosenessUpEvent(npc_id) then
                ScriptNPCClosenessEvent(npc_id)
            else
                ScriptNPCCommunicateDialog(npc_id)
            end


            PushPopupNPCCommunicateResult(npc_id)
            PushPopupTownNpc(npc_id)
            TownAutoZoomOut()
        else
            ScriptTownMoveToSide(TownCharacterGetNPC(npc_id))

            -- 해당 NPC와의 호감도가 최대치인 경우 일정 확률로 뮤비 춤 따라하기(분기처리)
            if CheckNPCClosenessMaxEvent(npc_id) then
                ScriptNPCClosenessEvent(npc_id)
            else
                ScriptNPCCommonDialog(npc_id)
            end

            PushPopupTownNpc(npc_id)            
            TownAutoZoomOut()            
        end

    end

end

