if OnCreate() then
    SetAnimation("ani", "Object/obj_build_dressshop_item_2x2_eff_stool_1")
    SetAnimation("ani", "UI_common/ui_dressshop_item_eff_1")
    SetAnimation("ani", "Object/obj_build_hairshop_item_2x2_eff_chair_1")
    SetAnimation("ani", "Object/obj_build_hairshop_item_2x2_eff_chair_2")
    SetAnimation("ani", "Object/obj_build_interiorshop_item_1x1_direct_left")
    SetAnimation("ani", "Object/obj_build_interiorshop_item_1x1_direct_center")
    SetAnimation("ani", "Object/obj_build_interiorshop_item_1x1_direct_right")
    SetAnimationByTownObjectID("ani", 10020319) -- "Object/obj_build_interiorshop_item_1x1_direct_car_1"
    SetAnimationByTownObjectID("ani", 10020318) -- "Object/obj_build_interiorshop_item_1x1_direct_box"
    SetAnimationByTownObjectID("ani", 10020320) -- "Object/obj_build_interiorshop_item_1x1_direct_car_2"

    LoadCharacter(352)
    LoadCharacter(353)
end

if OnEffectDressPurchased() then
    -- 옷가게 우측 발받침
    SetItem("stool", 10020204)

    -- 의상 변경 효과
    SetAnimation("eff", "Object/obj_build_dressshop_item_2x2_eff_stool_1")

    SetTownEmpty()

    CameraZoomIn("dancer", -80, 60, 2.4)

    -- 발받침 위로 캐릭터 배치 / 동작
    Item_SetCharacterFront("stool", "dancer", 0)
    Character_StandAt("dancer", 40, 40)
    Character_ActionID("dancer", 612270)
    -- 그 위로 의상 변경 효과
    Item_SetAniFront("stool", "eff")

    SoundPlay(53) --=SE=setPose
    Animation_Play("eff")

    SetCharacter("cloth_shop", 146)
    Character_Emoticon("dancer", "Characters/Emoticon_heart")
    Character_Emoticon("cloth_shop", "Characters/Emoticon_happy")

    Animation_WaitFinish("eff")

    -- GoBackTown() --  // 스크립트가 케릭터 refresh() 막고 있어서 밖에 들어가야할듯..
end

if OnEffectDressChanged() then
    -- 의상 변경 효과
    SetAnimation("eff", "UI_common/ui_dressshop_item_eff_1")

    SetTownEmpty()

    CameraZoomIn("dancer", 0, 63, 2.4)

    --  캐릭터 동작
    Character_ActionID("dancer", 612269)
    -- 그 위로 의상 변경 효과
    Character_SetAniFront("dancer", "eff")

    SoundPlay(53) --=SE=setPose
    Animation_Play("eff")
    Animation_SetPos("eff", -100, -120)
    Character_Emoticon("dancer", "Characters/Emoticon_heart")
    Animation_WaitFinish("eff")

    -- GoBackTown() --  // 스크립트가 케릭터 refresh() 막고 있어서 밖에 들어가야할듯..
end

if OnEffectHairChanged() then
    -- 헤어샾 손님의자 발받침
    SetItem("chair", 10020408)

    -- 헤어 변경 효과
    SetAnimation("eff1", "Object/obj_build_hairshop_item_2x2_eff_chair_1")
    SetAnimation("eff2", "Object/obj_build_hairshop_item_2x2_eff_chair_2")

    SetTownEmpty()

    CameraZoomIn("dancer", 0, 63, 2.4)

    -- 의자 위로 캐릭터 배치 / 동작
    Item_SetCharacterFront("chair", "dancer", 0)
    Character_StandAt("dancer", 40, 20)
    Character_ActionID("dancer", 612271)
    -- 그 위로 헤어 변경 효과
    Item_SetAniFront("chair", "eff1")
    Animation_Play("eff1")
    Animation_WaitFinish("eff1")

    Item_UnsetAni("chair", "eff1")

    x = Item_GetX("chair")
    y = Item_GetY("chair")
    Character_WaitMoveTo("dancer", x+120, y+40)

    Character_StandAt("dancer", 120, 40)
    Character_ActionID("dancer", 612272)
    Item_SetAniFront("chair", "eff2")
    Animation_Play("eff2")
    Animation_SetPos("eff2", 120, 40)

    SetCharacter("beauty_shop", 145)
    Character_Emoticon("dancer", "Characters/Emoticon_heart")
    Character_Emoticon("beauty_shop", "Characters/Emoticon_haha")

    Animation_WaitFinish("eff2")

    -- GoBackTown() --  // 스크립트가 케릭터 refresh() 막고 있어서 밖에 들어가야할듯..
end

if OnEffectInteriorPlace() then
    SetAnimation("eff_left", "Object/obj_build_interiorshop_item_1x1_direct_left")
    SetAnimation("eff_right", "Object/obj_build_interiorshop_item_1x1_direct_right")

    w = Item_GetW("item")
    Animation_SetPos("eff_right", w, 0)

    Item_SetAniFront("item", "eff_left")
    Item_SetAniFront("item", "eff_right")

    Animation_Play("eff_left")
    Animation_Play("eff_right")

    Animation_WaitFinish("eff_left")
end

if OnEffectInteriorReplace() then
    w = Item_GetW("item")
    cnt = w/40
    cnt = cnt - 1

    SetAnimation("eff_left", "Object/obj_build_interiorshop_item_1x1_direct_left")
    Item_SetAniFront("item", "eff_left")
    Animation_Play("eff_left")

    SetAnimation("eff_right", "Object/obj_build_interiorshop_item_1x1_direct_right")
    Item_SetAniFront("item", "eff_right")
    Animation_SetPos("eff_right", w, 0)
    Animation_Play("eff_right")

    idx = 0
    while idx < cnt do
        SetAnimation("eff_center" .. idx, "Object/obj_build_interiorshop_item_1x1_direct_center")
        Item_SetAniFront("item", "eff_center" .. idx)
        Animation_SetPos("eff_center" .. idx, idx * 40, 0)
        Animation_Play("eff_center" .. idx)
        idx = idx + 1
    end

    Wait(0.2)
    Item_Hide("item")
    Animation_WaitFinish("eff_left")
end

if OnEffectInteriorAdjust() then
    CameraMapSet(0, 160, 1.0)

    SetAnimation("box", "Object/obj_build_interiorshop_item_1x1_direct_box")
    Animation_SetAsTownObject("box")
    Animation_SetPos("box", -320, 40)
    Animation_PlayRepeat("box")

    -- 차 뒤에서 걸어나와 좌표값으로 간 후 동작 시작, 반복재생
    SetCharacter("worker1", 352)
    HideNameTag("worker1")
    Character_StandAt("worker1", -160, 160)
    Character_ActionID("worker1", 612273)

    SetAnimation("car1", "Object/obj_build_interiorshop_item_1x1_direct_car_1")
    Animation_SetAsTownObject("car1")
    Animation_SetPos("car1", -80, 80)
    Animation_Play("car1")
    Animation_WaitFinish("car1")
    Animation_Hide("car1")

    SetAnimation("car2", "Object/obj_build_interiorshop_item_1x1_direct_car_2")
    Animation_SetAsTownObject("car2")
    Animation_SetPos("car2", -80, 80)
    Animation_Play("car2")
    Animation_WaitFinish("car2")

    -- 차 뒤에서 걸어나오는 모션 후, 좌표값위치에서 동작 시작, 손에는 상자를 들고
    SetCharacter("worker2", 353)
    HideNameTag("worker2")
    Character_StandAt("worker2", 160, 120)
    Character_WaitMoveAcrossTo("worker2", 200, 120)
    Character_ActionID("worker2", 612274)
    Wait(1)

    -- 위의 재생이 끝나면 바로 재생, 역시나 손에는 상자 들고, 아카데미의 문으로 들어감
    Character_SetRoamingAction("worker2", 612275, 0)
    Character_WaitMoveTo("worker2", 0, -320)

    Wait(1)
    SetCharacter("interior_shop", 144)
    SetCharacter("user", 1)

    -- Wait(1)

    Character_Hide("worker1")
    Character_Hide("worker2")
    UnsetCharacter("worker1")
    UnsetCharacter("worker2")
end

if OnEffectInteriorExchange() then
    CameraMapSet(0, 160, 1.0)

    SetAnimation("coin", "Object/obj_build_interiorshop_item_1x1_direct_gold")
    Animation_SetAsTownObject("coin")
    Animation_SetPos("coin", 0, 40)
    Animation_Hide("coin")
    SetCharacter("interior_shop", 144)
    SetCharacter("user", 1)
    Character_StandAt("interior_shop", -40, 40)
    Character_StandAt("user", 40, 40)
    Character_ActionID("interior_shop", 612309)
    Character_ActionID("user", 612308)
    Animation_Show("coin")
    Animation_Play("coin")
    Wait(1)
    Character_Idle("user")
    Wait(3)
    Character_Idle("interior_shop")
    Animation_Hide("coin")
    Character_Emoticon("interior_shop", "Characters/Emoticon_heart")
    Character_Emoticon("user", "Characters/Emoticon_heart")
    Wait(1)

end

if OnEffectInteriorGoBack() then
    SetCharacter("interior_shop", 144)
    SetCharacter("user", 1)

    CameraZoomIn("", -34*40+40, 14*40 + 50,  1.5)
    Wait(0.5)
    -- 인테리어 샵으로 이동
    Character_StandAt("interior_shop", -34*40, 14*40)
    Character_StandAt("user", -34*40+80, 14*40)
    Wait(0.5)
end

